/*
File created 19/11/2008 by Nick Brown
*/
var PHCurve:=class rootType
(		
	var dynamic donedeclaration;
	var dynamic shape;
	var dynamic calleddec:=false;
	var display:=method[] 
	(
		print "gadgetPHCurve -> ";
		core.display[];
	);
	
	var init:=method[]
	(
		dependency.addinclude["<meshamgadget.h>"];
		donedeclaration:=false;
		//dependency.addinclude["<stdlib.h>"];		
		super;
		startroot[];
		this
	);
	
	var generateCode:=method[]
	(
		//output.clearline[];
		//if (getVariable[].hasBeenDeclared[]) donedeclaration:=true;
		if (calleddec==false) 
		(
			donedeclaration:=true;
			output.clearline[];
			output.ignoretillnewline[];	
		);
		if (donedeclaration==false)
		{
			//output.clearline[];
			output.add["MESHGADregisterPHCurve(\""];			
			(getVariable[]).generateName[];
			output.add["\\0\","];						
			shape.generateCode[];			
			output.add[")"];
		};
		//output.ignoretillnewline[];	
	);
	
	var destroy:=method[]
	(
		output.add["MESHGADfreePHCurve("];
		(getVariable[]).generateName[];
		output.add[");"];
		output.newline[];
	);
	
	var generateAccess:=method[x,i]
	{
		if (dotstr="key")
		(
			x.generateCode[];
			output.add["="];
			output.add["MESHGADgetPHCurveelementkey("];
			(getVariable[]).generateName[];
			output.add[","];
			i.lget[0].generateCode[];
			output.add[");"];
			output.newline[];
			return true;
		);
		
		if (dotstr="orderadded")
		(
			x.generateCode[];
			output.add["="];
			output.add["MESHGADgetPHCurveelementorderadded("];
			(getVariable[]).generateName[];
			output.add[","];
			i.lget[0].generateCode[];
			output.add[");"];
			output.newline[];
			return true;
		);
		
		if (dotstr="totalcells")
		(
			x.generateCode[];
			output.add["="];
			output.add["MESHGADgetPHCurvetotalcells("];
			(getVariable[]).generateName[];
			output.add[");"];
			output.newline[];
			return true;
		);
				
		output.add["memcpy(&"];
		x.generateCode[];
		output.add[",("];
		output.add[(shape.getstoredtype[].getCoreType[].t).getDeclaration[]];	
		output.add[" *) MESHGADgetPHCurveelement("];
		(getVariable[]).generateName[];
		output.add[","];
		i.lget[0].generateCode[];
		output.add["),sizeof("];
		if (shape.isavariable[])
		(
			output.add[(shape.getstoredtype[].getCoreType[].t).getDeclaration[]];	
		) else (
			output.add[(shape.getCoreType[].t).getDeclaration[]];	
		);
		output.add["));"];	
		output.newline[];
		return true;
	};
		
	var getCoreType:=method[] this;
	
	var generateAssignment:=method[x,i]
	{
	skip;
	};
	
	var getdottype:=method[thestring]
	(
	 	if ((thestring="key") || (thestring="totalcells")) return Longg;
	 	if (thestring="orderadded") return Int;
	);
	
	var getDotValue:=method[x,i]
	(
		return new unknown[];
	);
					
	var getDeclaration:=method[] "MESHPeanoHandle";
	
	var generateDeclaration:=method[]
	(
		calleddec:=true;
		output.add["MESHPeanoHandle"];
	);	
	
	var clone:=method[]
    {
    	var rety:=new PHCurve[];	    	
    	rety.alone:=alone;
    	rety.shape:=shape;
    	rety.calleddec:=calleddec;
    	rety.donedeclaration:=donedeclaration;    	
    	rety.core:=core.clone[];
    	return rety;
    };
			
	var setarg:=method[x,i]
	(
		shape:=x;	
	);		
	
	var valid0:=method[] 
	(
		if (!alone) (core.valid1[];)	
	);	
		
	var check:=method[v]
	(
		if (v::thisclass) (return true;);
		return core.check[v];
	);
);