/*
File created 19/11/2008 by Nick Brown
*/
var SpaceShape:=class rootType
(		
	var dynamic donedeclaration:=false;
	var dynamic dimensioncentre;
	var dynamic typedone:=false;
	var dynamic calleddec:=false;
	var display:=method[] 
	(
		print "SpaceShape -> ";
		core.display[];
	);
	
	var init:=method[thistype]
	(
		dependency.addinclude["<meshamgadget.h>"];
//		dependency.addinclude["<stdlib.h>"];
		dependency.addinclude["<string.h>"];
		dimensioncentre:=new ArrayList[];
		super;
		startroot[];
		if (((thistype :: coretype)==true) || ((thistype :: particletype)==true))	// replaces previous so it can handle all element types
		(			
			t:=thistype;
			typedone:=true;
		);	
		this
	);
	
	var getdottype:=method[thestring] t.getdottype[thestring];
	var getDotValue:=method[x,i] t.getDotValue[x,i];
	
	var generateCode:=method[]
	(
		if (calleddec==false) 
		(
			donedeclaration:=true;
			output.clearline[];
			output.ignoretillnewline[];	
		);
		if (donedeclaration==false)
		{			
			donedeclaration:=true;
			output.clearline[];
			output.newline[];
			output.add["double MESHspaceminmax["];
			output.add[dimensioncentre.getsize[] % 2];
			output.add["][2] = {"];
			var i;
			for i from 0 to dimensioncentre.getsize[] - 1
			(
				if (((i % 2) * 2) == i) output.add["{"];													
				dimensioncentre.aget[i].generateCode[];
				if (((i % 2) * 2) != i) output.add["}"];
				if (i != dimensioncentre.getsize[] - 1) output.add[","];
			);
			output.add["};\n"];
			generateDeclaration[];
			output.add[" "];
			getVariable[].generateCode[];
			output.add["=MESHregisterShapeSpace(\""];			
			(getVariable[]).generateName[];
			output.add["\\0\","];			
			output.add[dimensioncentre.getsize[] % 2];
			output.add[",&MESHspaceminmax[0][0])"];
		};
	);
	
	
	var destroy:=method[]
	(
		output.add["MESHfreeShapeSpace("];
		(getVariable[]).generateName[];
		output.add[");"];
		output.newline[];
	);
		
	var generateAccess:=method[x,i]
	{
		if (i.getsize[]==dimensioncentre.getsize[] % 2)
		(
			output.clearline[];
			output.newline[];
			output.add["{double MESHtempvarspacecoords[]={"];
			var j;
			for j from 0 to i.getsize[] - 1
			(
				i.lget[j].generateCode[];
				if (j != (i.getsize[]) - 1) output.add[","];
			);			
			output.add["};\n"];
			output.add["memcpy(&"];
			x.generateCode[];
			output.add[",("];
			output.add[t.getDeclaration[]];			
			output.add[" *) MESHgetdatafromShapeSpace("];			
			(getVariable[]).generateName[];
			output.add[",MESHtempvarspacecoords),sizeof("];
			output.add[t.getDeclaration[]];			
			output.add["));}"];	
			output.newline[];
			return true;
		);
	};
		
	var getCoreType:=method[] this;
	
	var generateAssignment:=method[x,i]
	{
		if (i.getsize[]==dimensioncentre.getsize[] % 2)
		(
			output.add["{double MESHtempvarspacecoords[]={"];
			var j;
			for j from 0 to i.getsize[] - 1
			(
				i.lget[j].generateCode[];
				if (j != (i.getsize[]) - 1) output.add[","];
			);			
			output.add["};\nMESHaddtoShapeSpace("];			
			(getVariable[]).generateName[];
			output.add[",&"];	
			x.generateCode[];
			output.add[",MESHtempvarspacecoords);}"];	
			output.newline[];
			return true;
		);
	};
					
	var getDeclaration:=method[] "MESHShapeSpaceHandle";
	
	var generateDeclaration:=method[]
	(
		calleddec:=true;
		output.add["MESHShapeSpaceHandle"];
	);	
	
	var clone:=method[]
    {
    	var rety:=new SpaceShape[t];	    	
    	rety.t:=t;
    	rety.alone:=alone;
    	rety.calleddec:=calleddec;
    	rety.typedone:=typedone;
    	rety.dimensioncentre:=dimensioncentre;
    	rety.donedeclaration:=donedeclaration;    	
    	rety.core:=core.clone[];
    	return rety;
    };
			
	var setarg:=method[x,i]
	(
		if (i==0) 
		(				 		
			if (!typedone)
			(
				t:=x;			
			);			
		) else (
			dimensioncentre.aadd[x];
		);
	);		
	
	var valid0:=method[] 
	(
		if (!alone) (core.valid1[];)	
	);	
		
	var check:=method[v]
	(				
		if (v::thisclass) (return true;);
		if (t.check[v]) (return true;);
		return core.check[v];
	);
);