/*
File created 29/1/2008 by Nick Brown
*/
var alltoall:=class subType
(	
	var dynamic each;
	var dynamic senddsp;
	var dynamic recvdsp;
	var dynamic recvsizes;
	var init:=method[]
	(
		super;
		startroot[];
		this
	);
	
	var optimiseAccess:=method[x,i]
	(
		if (!((x.getstoredtype[]).getheldon[]==false))
    	(
    		throw error "Can only send alltoall if the variable is held on each process";
    	);
    	
    	if (!(getChainStart[].getheldon[]==false))
    	(
    		throw error "Can only send alltoall if the shared variable is held on each process";
    	);
	);
	
    var optimiseAssignment:=method[x,i]
    (
    	if ((!((x.getstoredtype[]).getheldon[]==false)) && (!(((x.getstoredtype[]).getheldon[]) :: commgroup)))
    	(
    		throw error "Can only send alltoall if the variable is held on each process";
    	);
    	
    	if ((!(getChainStart[].getheldon[]==false)) && (!(((getChainStart[]).getheldon[]) :: commgroup)))
    	(
    		throw error "Can only send alltoall if the shared variable is held on each process";
    	);
    	
    	// now check they are both the same
    	if ( ((x.getstoredtype[].getheldon[]) :: commgroup) && ((getChainStart[].getheldon[]) :: commgroup))
    	(
    		if ((x.getstoredtype[].getheldon[]).checkEquals[(getChainStart[].getheldon[]).getGroup[]]==false)
    		(
    			throw error "The two comm groups must be identical in the alltoall primative";
    		);
    	);
    );
		
	var getSuperTypeId:=method[] return new ArrayList[4,41];
	
	var clone:=method[]
    {
    	var rety:=new alltoall[];	    	    	
    	rety.each:=each;
    	rety.senddsp:=senddsp;
    	rety.recvdsp:=recvdsp;
    	rety.recvsizes:=recvsizes;    	
    	rety.alone:=alone;
    	rety.core:=core.clone[];    
    	return rety;
    };
    
    var generateAlltoAll:=method[x,i,v]
    {
    	if ((!(recvsizes== null)))
    	(
    		output.add["MPI_Alltoallv("];
    	) else (
   	 		output.add["MPI_Alltoall("];
   	 	);
   	 
   	 	if ((x.getstoredtype[]).isElementType[] == true) output.add["&"];   	 	
		x.generateName[];
		output.add[","];	
		if ((!(recvsizes== null)))
		(
			each.generateCode[];
		) else (
			output.add[each];
		);
		output.add[","];
		if ((!(recvsizes== null))) (senddsp.generateCode[]; output.add[","];);
		((x.getstoredtype[]).getCoreType[]).generateMPIDeclaration[];
		output.add[",&"];
		v.generateMethodInvoke[i];
		output.add[","];
		if ((!(recvsizes== null)))
		(
			recvsizes.generateCode[];
		) else (
			output.add[each];
		);
		output.add[","];
		if ((!(recvsizes== null))) (recvdsp.generateCode[]; output.add[","];);
		((v.getstoredtype[]).getCoreType[]).generateMPIDeclaration[];		
		output.add[","];
		if (x.isavariable[]==true)
		(
			if ((x.getstoredtype[].getheldon[]) :: commgroup)
			(
				output.add["MESH_COMM_VAR"];
				output.add[(x.getstoredtype[].getheldon[]).getCommId[]];
			) else (
				output.add["MPI_COMM_WORLD"];
			);
		) else (
			output.add["MPI_COMM_WORLD"];
		);		
		output.add[");"];
		output.newline[];
		misc.performCommErrorCheck[];
		return true;
    };
    
    var generateAccess:=method[x,i] generateAlltoAll[getVariable[],i,x];
    
    var generateAssignment:=method[x,i] 
    (
    	if ((x.getstoredtype[].getheldon[]) :: commgroup)
		(
			if ((x.getstoredtype[].getheldon[]).isWithin[parallelgeneratecounter - 1]==false) return true;
		);	
    	generateAlltoAll[x,i,getVariable[]];
    );
    
    var setarg:=method[x,i]
	(			
		if (i==0) 
		(
			if ( ((x.getValue[])==null) || ((x.getValue[]) :: unknown))
			(
				each:=x;
			) else (
				each:=(x.getValue[]);
			);			
		);				
		
		if (i==1) recvsizes:=x;
		if (i==2) senddsp:=x;
		if (i==3) recvdsp:=x;
	);
	
	var valid1:=method[] 
	(
		if (!alone) (this.core.valid412[];)	
	);	
	
	var valid11:=method[] 
	(
		if (!alone) (this.core.valid412[];)	
	);
	
	var valid6:=method[] 
	(
		if (!alone) (this.core.valid412[];)	
	);
);