/*
File created 24/1/2008 by Nick Brown
*/
var dist:=class rootType
(
	var dynamic entriesperprocess;
	var distributedsizetoalloc:=0;
	var init:=method[]
	(
		super;
		startroot[];	
		entriesperprocess:=new HashMap[];	
		this
	);
	
	
	var startdist:=method[]
	(
		entriesperprocess:=new HashMap[];
		startroot[];
		this;
	);
	
	var checkAllocationSame:=method[]
	{
		var num:=null;
		var i:=entriesperprocess.hgetiterator[];
		while (i.hasNext[])
		(
			var n:=(i.next[]).getdata[];
			if (num==null) num:=n;
			if ((num !=n) || (num :: unknown)) return false;
		);
		return true;
	};
	
	var checkStaticKnowledge:=method[]
	{
		var i:=entriesperprocess.hgetiterator[];
		while (i.hasNext[])
		(
			var n:=(i.next[]).getdata[];			
			if (n :: unknown) return false;
		);
		return true;
	};	
	
	var updateProcessAllocation:=method[blocks]
	{		
		var currentp:=0;
		var elements:=0;
		var it:=blocks.agetiterator[];
		while (it.hasNext[])
		(
			var b:=(it.next[]).getdata[];
			if (b.getWhichProcessOn[] == currentp)
			(
				if ((!((b.getSize[]) :: unknown)) && (!((elements) :: unknown)))
				(					
					elements:=elements + b.getSize[];
				) else (					
					elements:=new unknown[];
				);
			) else (						
				setEntryForProcess[currentp,elements];
				currentp:=currentp + 1;
				elements:=b.getSize[];
			);
		);
		setEntryForProcess[currentp,elements];
	};
	
	var generateCode:=method[]
	{		
		scopeinfo.addVar[getVariable[]];		
		var sa:=checkAllocationSame[];
		var staticanalysis:=checkStaticKnowledge[];
		if ((sa==false) && (staticanalysis==true))
		(
			output.clearline[];	
			output.add["int distributedsizetoalloc"];
			output.add[distributedsizetoalloc];
			output.add["[]={"];
			var i;
			for i from 0 to entriesperprocess.getsize[] - 1
			(
				var sizeofe:=entriesperprocess.hget[i];
				output.add[sizeofe];
				if (i != entriesperprocess.getsize[] - 1) output.add[","];
			);
			output.add["};\n"];
			(getVariable[]).generateDeclaration[]; 				
 			output.add[" "];
 			(getVariable[]).generateName[]; 				
			output.add["=("];
		) else (
			output.add["("];
		);
		(getVariable[]).getstoredtype[].generateDeclaration[];
		output.add[") malloc (sizeof("];
		(getVariable[]).getstoredtype[].getCoreType[].generateDeclaration[];
		output.add[") * "];
		if (staticanalysis==true)
		(
			if (sa==false)
			(
				output.add["distributedsizetoalloc"];
				output.add[distributedsizetoalloc];
				output.add["[myrank]"];
				distributedsizetoalloc:=distributedsizetoalloc + 1;
			) else (
				output.add[entriesperprocess.hget[0]];
			);
		) else (
			// default as whole size!
			output.add[(getVariable[]).getstoredtype[].getSize[]];
		);
		output.add[");"];
		output.newline[];
		output.insertDynamicCheckMalloc[getVariable[]];
		output.newline[];
		output.ignoretillnewline[];
		return null;
	};
	
	var setEntryForProcess:=method[pid,entry]
	{
		var individualentry:=entriesperprocess.hget[pid];
		if (individualentry==null) individualentry:=0;
		if (individualentry :: unknown) individualentry:=0;
		if (entry :: unknown)
		(
			entriesperprocess.hput[pid,entry];			
		) else (		
			if (individualentry <= entry) 
			(
				individualentry:=entry;
				entriesperprocess.hput[pid,individualentry];			
			);
		);
	};
	
	var isDistributed:=method[] true;
	var getheldon:=method[] false;
	
	var clone:=method[]
    {
    	var rety:=new dist[];	   
    	rety.entriesperprocess:=entriesperprocess; 	
    	rety.alone:=alone;
    	rety.core:=core.clone[];    
    	return rety;
    };
    
    var setarg:=method[x,i] skip;
    
    var valid1:=method[] 
	(
		if (!alone) (this.core.valid2[];)	
	);	
	
	var valid11:=method[] 
	(
		if (!alone) (this.core.valid2[];)	
	);
	
	var check:=method[v]
	(
		if (v::thisclass) (return true;);
		return core.check[v];
	);
);