/*
File created 31/1/2008 by Nick Brown
*/
var miscclass:=class Value
(
	// misc functionality
	var dirtyvalues;
	var asyncvars;
	var init:=method[] 
	(
		dirtyvalues:=new ArrayList[];
		asyncvars:=new ArrayList[];
	);
	var performCommErrorCheck:=method[]
	(
		if (intry==true)
		(
			output.add["if (MESHcommerror==1){goto commerror"];
			output.add[commerrorcnt];
			output.add[";}"];
			output.newline[];
		);
	);
	
	var checkIsASync:=method[x]
	{
		var j:=0;
		for j from 0 to asyncvars.getsize[] - 1
		(
			if (asyncvars.aget[j]==x) return true;
		);
		return false;
	};
	
	var checkIllegalAccess:=method[x]
	{
		var j:=dirtyvalues.agetiterator[];
		while (j.hasNext[])
		(
			var tn:=(j.next[]);
			if (!(tn == null))
			(
				tn:=tn.getdata[];		
				if (tn.thevariable==x) return true;
				if (tn.linkto==x) return true;
			);
		);	
		return false;
	};
	
	var clearSync:=method[x]
	{
		var newlist:=new ArrayList[];	
		var j:=0;
		for j from 0 to asyncvars.getsize[] - 1
		(
			if (((asyncvars.aget[j] == x)==false) && (!(asyncvars.aget[j] == null)))
			(				
				newlist.aadd[asyncvars.aget[j]];
			);
		);
		asyncvars.clear[];
		for j from 0 to newlist.getsize[] - 1
		(		
			asyncvars.aadd[newlist.aget[j]];
		);
		newlist.clear[];
	};
	
	var addASyncVar:=method[x] asyncvars.aadd[x];		
	
	var addDirty:=method[x]
	{
		var toadd:=new dirtystorageclass[x];
		dirtyvalues.aadd[toadd];
		asyncvars.aadd[x];
	};
	
	var addDirtyandLink:=method[x,l]
	{
		var toadd:=new dirtystorageclass[x];
		toadd.setLinkTo[l];
		dirtyvalues.aadd[toadd];
		asyncvars.aadd[x];
	};
	
	var cleanDirtyLink:=method[x]
	{	
		var j:=dirtyvalues.agetiterator[];
		while (j.hasNext[])
		(
			var tn:=((j.next[]));
			if (!(tn==null)) 
			(
				tn:=tn.getdata[];
				if (tn.thevariable==x) tn.clean[];
			);
		);
		return removeDirtyVar[x];
	};
	
	var removeDirtyVar:=method[x]
	{
		var j:=0;
		var doneremoval:=false;
		for j from 0 to dirtyvalues.getsize[] - 1
		(
			if (!((dirtyvalues.aget[j])==null))
			(			
			if (((dirtyvalues.aget[j]).thevariable) == x)
			(				
				dirtyvalues.aremove[j];
				doneremoval:=true;
			);
			);
		);
		return doneremoval;
	};
	
	var cleanDirtyValues:=method[]
	{
		var j:=dirtyvalues.agetiterator[];
		while (j.hasNext[])
		(
			var zz:=j.next[];
			if (!(zz==null))
			(
				zz:=zz.getdata[];
				zz.clean[];
			);
		);	
		dirtyvalues.clear[];
	};
	
	var dirtyAccessVar:=method[x]
	(
		warnings.add[];
		warnings.addtext["Variable "];		
		warnings.addtext[x.getName[]];
		warnings.addtext[" is used at a point where value is not deterministic"];
	);
);

var dirtystorageclass:=class Value
(
	var dynamic thevariable;
	var dynamic linkto;
	var init:=method[v] thevariable:=v;
	var setLinkTo:=method[l] linkto:=l;
	var clean:=method[]
	(
		thevariable.setDirty[false];
		if (!(linkto == null)) linkto.setDirty[false];
	);
);
var misc:=new miscclass[];