/*
File created 14/10/2008 by Nick Brown
*/
var snapshot:=class rootType
(		
	var dynamic filename;
	var dynamic donedeclaration:=false;
	var display:=method[] 
	(
		print "gadgetsnapshot -> ";
		core.display[];
	);
	
	var init:=method[]
	(
		dependency.addinclude["<meshamgadget.h>"];
		dependency.addinclude["<stdlib.h>"];
		super;
		startroot[];
		this
	);
	
	var generateCode:=method[]
	(
		if (donedeclaration==false)
		{
			donedeclaration:=true;
			output.clearline[];
			output.newline[];
			output.add["MESHGADregistersnapshotfmt1("];
			filename.generateCode[];
			output.add[",\""];
			(getVariable[]).generateName[];
			output.add["\\0\","];
			if ((getChainStart[]).getheldon[]==false)
			(
				output.add["-1"];
			) else (
				(getChainStart[]).getheldon[].generateCode[];
			);
			output.add[")"];
			scopeinfo.addVar[(getVariable[])];
		};
	);
	
	var destroy:=method[]
	(
		output.add["MESHGADfreesnapfile(\""];
		(getVariable[]).generateName[];
		output.add["\\0\");"];
		output.newline[];
	);
	
	var generateAccess:=method[x,i]
	{
		if (i==null && dotstr="")
		(
			if (((x.getstoredtype[].getCoreType[]) :: snapshot) || ((x.getstoredtype[].getCoreType[]) :: snapshot2) || ((x.getstoredtype[].getCoreType[]) :: snapshotHDF5)) return false;
			output.add["MESHGADsnapfmt1parseparticles("];
			x.generateCode[];
			output.add[",\""];
			(getVariable[]).generateName[];
			output.add["\\0\","];
			output.add[x.getCurrentType[].getSize[]];
			output.add[");"];
			output.newline[];
			return true;
		);		
	};
	
	var generateCopyCode:=method[x,str]
	{	
		if (str="numberofparticles") output.add["MESHGADsnapshotsetnumparticles(\""];
		if (str="mynumberofparticles") output.add["MESHGADsnapshotsetmynumparticles(\""];
		if (str="massofparticles") output.add["MESHGADsnapshotsetparticlemass(\""];
		if (str="totalnumberofparticles") output.add["MESHGADsnapshotsettotalnumparticles(\""];
		if (str="time") output.add["MESHGADsnapshotsettime(\""];
		if (str="redshift") output.add["MESHGADsnapshotsetredshift(\""];
		if (str="files") output.add["MESHGADsnapshotsetfilespersnapshot(\""];
		if (str="boxsize") output.add["MESHGADsnapshotsetboxsize(\""];
		if (str="omega0") output.add["MESHGADsnapshotsetomega0(\""];
		if (str="omegalambda") output.add["MESHGADsnapshotsetomegalambda(\""];
		if (str="hubble") output.add["MESHGADsnapshotsethubble(\""];
		if (str="entropy") output.add["MESHGADsnapshotsetentropy(\""];		
		(getVariable[]).generateName[];
		output.add["\\0\","];
		(x.getstoredtype[].getCoreType[]).generateDotCode[str];
		output.add[");"];
		output.newline[];
	};
	
	var getCoreType:=method[] this;
	
	var generateAssignment:=method[x,i]
	{
		if (dotstr != "")
		(
			if (dotstr="numberofparticles") output.add["MESHGADsnapshotsetnumparticles(\""];
			if (dotstr="mynumberofparticles") output.add["MESHGADsnapshotsetmynumparticles(\""];
			if (dotstr="massofparticles") output.add["MESHGADsnapshotsetparticlemass(\""];
			if (dotstr="totalnumberofparticles") output.add["MESHGADsnapshotsettotalnumparticles(\""];
			if (dotstr="time") output.add["MESHGADsnapshotsettime(\""];
			if (dotstr="redshift") output.add["MESHGADsnapshotsetredshift(\""];
			if (dotstr="files") output.add["MESHGADsnapshotsetfilespersnapshot(\""];
			if (dotstr="boxsize") output.add["MESHGADsnapshotsetboxsize(\""];
			if (dotstr="omega0") output.add["MESHGADsnapshotsetomega0(\""];
			if (dotstr="omegalambda") output.add["MESHGADsnapshotsetomegalambda(\""];
			if (dotstr="hubble") output.add["MESHGADsnapshotsethubble(\""];
			if (dotstr="entropy") output.add["MESHGADsnapshotsetentropy(\""];
			(getVariable[]).generateName[];
			output.add["\\0\","];
			x.generateCode[];
			output.add[");"];
			output.newline[];
			return true;
		) else (
			if (i==null)
			(
				if (((x.getstoredtype[].getCoreType[]) :: snapshot) || ((x.getstoredtype[].getCoreType[]) :: snapshot2) || ((x.getstoredtype[].getCoreType[]) :: snapshotHDF5))
				(
					output.add["{MESHGADparticle * MESHtempparticledump=malloc(sizeof(MESHGADparticle) * MESHGADsnapshotgetparticlesum(\""];
					x.generateName[];
					output.add["\\0\"));\n"];
					if ((x.getstoredtype[].getCoreType[]) :: snapshot) output.add["MESHGADsnapfmt1parseparticles(MESHtempparticledump,\""];
					if ((x.getstoredtype[].getCoreType[]) :: snapshot2) output.add["MESHGADsnapfmt2parseparticles(MESHtempparticledump,\""];
					if ((x.getstoredtype[].getCoreType[]) :: snapshotHDF5) output.add["MESHGADsnapfmtHDF5parseparticles(MESHtempparticledump,\""];
					x.generateCode[];
					output.add["\\0\",MESHGADsnapshotgetparticlesum(\""];
					x.generateName[];
					output.add["\\0\"));\n"];
					generateCopyCode[x,"numberofparticles"];					
					generateCopyCode[x,"massofparticles"];
					generateCopyCode[x,"totalnumberofparticles"];
					generateCopyCode[x,"time"];
					generateCopyCode[x,"redshift"];
					generateCopyCode[x,"files"];
					generateCopyCode[x,"boxsize"];
					generateCopyCode[x,"omega0"];
					generateCopyCode[x,"omegalambda"];
					generateCopyCode[x,"hubble"];
					generateCopyCode[x,"entropy"];
					output.add["MESHGADsnapfmt1saveparticles(MESHtempparticledump,\""];
					(getVariable[]).generateCode[];
					output.add["\\0\",MESHGADsnapshotgetparticlesum(\""];
					x.generateName[];
					output.add["\\0\"));\nfree(MESHtempparticledump);}"];
					output.newline[];
					return true;
				) else (
					output.add["MESHGADsnapfmt1saveparticles("];
					x.generateCode[];
					output.add[",\""];
					(getVariable[]).generateCode[];
					output.add["\\0\","];
				
					if ((x.getCurrentType[].getSize[]) :: unknown)
					(
						x.getCurrentType[].getSizeIndex[0].generateName[];
					) else (
						output.add[x.getCurrentType[].getSize[]];
					);
					output.add[");"];
					output.newline[];
					return true;
				);
			);
		);
	};
	

	var generateDotCode:=method[x]
	{				
		if (x="numberofparticles") output.add["MESHGADsnapshotgetnumparticles(\""];
		if (x="mynumberofparticles") output.add["MESHGADsnapshotgetmynumparticles(\""];
		if (x="massofparticles") output.add["MESHGADsnapshotgetparticlemass(\""];
		if (x="totalnumberofparticles") output.add["MESHGADsnapshotgettotalnumparticles(\""];
		if (x="time") output.add["MESHGADsnapshotgettime(\""];
		if (x="redshift") output.add["MESHGADsnapshotgetredshift(\""];
		if (x="files") output.add["MESHGADsnapshotgetfilespersnapshot(\""];
		if (x="boxsize") output.add["MESHGADsnapshotgetboxsize(\""];
		if (x="omega0") output.add["MESHGADsnapshotgetomega0(\""];
		if (x="omegalambda") output.add["MESHGADsnapshotgetomegalambda(\""];
		if (x="hubble") output.add["MESHGADsnapshotgethubble(\""];
		if (x="entropy") output.add["MESHGADsnapshotgetentropy(\""];
		(getVariable[]).generateName[];
		output.add["\\0\")"];
	};				
		
	var getDotValue:=method[x,i]
	(
		return new unknown[];
	);
	
	var getdottype:=method[thestring]
	(
	 	return getKeywordType[thestring];
	);
	
	var getKeywordType:=method[thestring]
	{
		if (thestring="numberofparticles" || thestring="mynumberofparticles") 
		(
			var t:=new array[Int,6];
			t.setarg[new Range[6,6],1];
			var alloc:=new allocated[];
			alloc.allocationtype:=new multiple[];
			alloc + t;
			return alloc;
		);
		if (thestring="massofparticles") 
		(
			t:=new array[Doublee,6];
			t.setarg[new Range[6,6],1];
			alloc:=new allocated[];
			alloc.allocationtype:=new multiple[];
			alloc + t;
			return alloc;
		);
		if (thestring="totalnumberofparticles") 
		(
			t:=new array[Int,6];
			t.setarg[new Range[6,6],1];
			alloc:=new allocated[];
			alloc.allocationtype:=new multiple[];
			alloc + t;
			return alloc;
		);
		if (thestring="time") return Doublee;
		if (thestring="redshift") return Doublee;
		if (thestring="files") return Int;
		if (thestring="boxsize") return Doublee;
		if (thestring="omega0") return Doublee;
		if (thestring="omegalambda") return Doublee;
		if (thestring="hubble") return Doublee;
		if (thestring="entropy") return Int;
		return null;
	};
	
	var setDotValue:=method[x,i]
	(
		skip;
	);
	
	var generateDeclaration:=method[]
	(
		output.add["void *"];
	);	
	
	var clone:=method[]
    {
    	var rety:=new snapshot[];	    	
    	rety.alone:=alone;
    	rety.donedeclaration:=donedeclaration;
    	rety.filename:=filename;
    	rety.core:=core.clone[];
    	return rety;
    };
			
	var setarg:=method[x,i]
	(
		if (i==0) filename:=x;
	);		
	
	var valid0:=method[] 
	(
		if (!alone) (core.valid1[];)	
	);	
		
	var check:=method[v]
	(
		if (v::thisclass) (return true;);
		return core.check[v];
	);
);