/*
File created 31/1/2008 by Nick Brown
*/

var allreduce:=class subType
(		
	var totcounter:=0;
	var dynamic action;
	var init:=method[]
	(
		super;
		startroot[];
		this
	);
	var getSuperTypeId:=method[] return new ArrayList[4,41];
	
	var setarg:=method[x,i]
	(
		if (i==0) action:=x.getValue[];
		if (i > 0)
		(
			errors.STypeAError[];
		);
	);
	//var getCoreType:=method[] return new Int;
	
	var generateDeclaration:=method[] core.generateDeclaration[];
	
	var generateCode:=method [] 
	(
		output.clearline[];
		output.ignoretillnewline[];
	);
	
	var optimiseAccess:=method[x,i]
	{
		if (!(getChainStart[].getheldon[]==false))
    	(
    		throw error "Can only reduce if the shared variable is held on each process";
    	);
	};
	
	var optimiseAssignment:=method[x,i]
	{
		if ((!(getChainStart[].getheldon[]==false)) && (!((getChainStart[].getheldon[]) :: commgroup)))
    	(
    		throw error "Can only reduce if the shared variable is held on each process";
    	);
	};
	
	var generateAccess:=method[x,i]
	{		
		generateAllReduce[(getVariable[]),i,x];
		return true;
	};
	
	var generateAssignment:=method[x,i]
	{		
		if ((getChainStart[].getheldon[]) :: commgroup)
		(
			if ((getChainStart[].getheldon[]).isWithin[parallelgeneratecounter - 1]==false) return true;
		);	
		generateAllReduce[x,i,(getVariable[])];
		return true;
	};
	
	var getSizeOfData:=method[i]
    {
    	var thesizeofdata:=((getVariable[]).getstoredtype[]).getSizeIndex[1];
    	if ((((getVariable[]).getstoredtype[]).getSize[]) :: unknown) return new unknown;
 		if  (thesizeofdata==null) thesizeofdata:=new Range[1,1];
 		if (i==null)
 		(
 			thesizeofdata:=new Range[((getVariable[]).getstoredtype[]).getSize[],((getVariable[]).getstoredtype[]).getSize[]];
 		) else ( 		
 			if (i.getsize[]==2) thesizeofdata:=new Range[1,1];
 		);
 		return thesizeofdata;
    };
	
	var generateAllReduce:=method[x,i,v]
	{
		if (x.isavariable[]==false)
    	(    		
    		(x.getCurrentType[]).generateDeclaration[];
    		output.add[" alltempreducevar"];
    		output.add[totcounter];
    		output.add["="];
    		x.generateCode[];
    		output.add[";\n"];
    	);
		output.add["MPI_Allreduce (&"];
		var newstack:=new stack[];
		if (x.isavariable[]==false)
    	(
			output.add["alltempreducevar"];
    		output.add[totcounter];				
		) else (
			x.generateMethodInvoke[newstack];
		);
		output.add[",&"];
		v.generateMethodInvoke[i];
		output.add[","];
		var sofd:=getSizeOfData[i];
		if (sofd :: unknown)
		(
			((getVariable[]).getstoredtype[]).getSizeIndex[0].generateCode[];
		) else (
			sofd.generateCode[];
		);
		output.add[","];
		((x.getstoredtype[]).getCoreType[]).generateMPIDeclaration[];
		output.add[","];
		generateAction[];
		output.add[","];
		if (v.isavariable[]==true)
		(
			if ((v.getstoredtype[].getheldon[]) :: commgroup)
			(
				output.add["MESH_COMM_VAR"];
				output.add[(v.getstoredtype[].getheldon[]).getCommId[]];
			) else (
				output.add["MPI_COMM_WORLD"];
			);
		) else (
			output.add["MPI_COMM_WORLD"];
		);		
		output.add[");"];
		output.newline[];
		totcounter:=totcounter + 1;
		misc.performCommErrorCheck[];
	};
		
	var generateAction:=method[]
	(
		if (action="min") return output.add["MPI_MIN"];
		if (action="max") return output.add["MPI_MAX"];
		if (action="sum") return output.add["MPI_SUM"];
		if (action="prod") return output.add["MPI_PROD"];
		if (action="land") return output.add["MPI_LAND"]; 
		if (action="band") return output.add["MPI_BAND"]; 
		if (action="lor") return output.add["MPI_LOR"];
		if (action="bor") return output.add["MPI_BOR"];
		if (action="lxor") return output.add["MPI_LXOR"]; 
		if (action="bxor") return output.add["MPI_BXOR"];
		if (action="minloc") return output.add["MPI_MINLOC"];
		if (action="maxloc") return output.add["MPI_MAXLOC"];
		if (action="replace") return output.add["MPI_REPLACE"];		
		throw error "Reduction Operation Unknown";	
	);
		
	var overrideAssignment:=method[] this;
	
	var generateWindowDeclaration:=method[] // override shared and do not display any window
	(
		// FIX - I dont like it
		output.add["//"];	// the caller to generateCode will try to add a ; therefore to override, just put comment in
	);
	
	//var getReturnType:=method[] return core.getTy[];
	
	var valid1:=method[] 
	(
		if (!alone) (this.core.valid411[];)	
	);	
	
	var valid11:=method[] 
	(
		if (!alone) (this.core.valid411[];)	
	);
	
	var valid6:=method[] 
	(
		if (!alone) (this.core.valid411[];)	
	);
	
	var check:=method[v]
	{
		if (v::thisclass) (return true;);
		if (v.check[Null]) return false;
		return true;
	};
	
		
	var clone:=method[]
    {
    	var rety:=new allreduce[];	    	
    	rety.action:=action;
    	rety.alone:=alone;
    	rety.core:=core.clone[];    
    	return rety;
    };
);