/*
File created 28/1/2008 by Nick Brown
*/
var broadcast:=class subType
(
	var dynamic root;
	var init:=method[]
	(
		super;
		startroot[];
		this
	);
	
	var getRoot:=method[] root;
	
	var optimiseAccess:=method[x,i] false;
    var optimiseAssignment:=method[x,i]
    (
    	dependency.addinclude["<string.h>"];
    	if ((!(getChainStart[].getheldon[]==false)) && (!((getChainStart[].getheldon[]) :: commgroup)))
    	(
    		throw error "Can only broadcast if the variable is held on each process";
    	);
    );
    
    var generateAccess:=method[x,i] return false;
    
    var generateAssignment:=method[x,i]
    {    	    	
    	if ((getChainStart[].getheldon[]) :: commgroup)
		(
			if ((getChainStart[].getheldon[]).isWithin[parallelgeneratecounter - 1]==false) return true;
		);		
		var vs:=1;
		if ((x.getstoredtype[].getSize[]) :: unknown)
		(
			vs:=new unknown[];
		) else (
    		if (x.isavariable[]) vs:=x.getstoredtype[].getSize[].a;  
    	);
    	var oldroot:=root;
    	root:=root.getValue[];
    	if ((root.a == parallelgeneratecounter - 1) && (root.a == root.b))
    	(    		    		    		  	
    		if (vs==1)
    		(
    			(getVariable[]).generateMethodInvoke[i];
				output.add["="]; // need memcpy too!
				if (x.isavariable[])
    			(
					x.generateMethodInvoke[new stack[]];
				) else (
					x.generateCode[];
				);
			) else (
				output.add["memcpy(&"];
				(getVariable[]).generateMethodInvoke[i];
				output.add[",&"];
				x.generateMethodInvoke[new stack[]];
				output.add[",sizeof("];
    			output.add[(getChainStart[]).getCoreType[].getDeclaration[]];
    			output.add[") * "];
				x.getstoredtype[].getSize[].generateCode[];
				output.add[")"];
			);
			output.add[";\n"];			
		) else (
			//if (parallelgeneratecounter==0)
			//(
				output.add["if (myrank=="];
				oldroot.generateCode[];
				output.add["){\n"];								
				if (vs==1)
    			(
    				(getVariable[]).generateMethodInvoke[i];
					output.add["="]; // need memcpy too!
					if (x.isavariable[])
    				(
						x.generateMethodInvoke[new stack[]];
					) else (
						x.generateCode[];
					);
				) else (
					output.add["memcpy(&"];
					(getVariable[]).generateMethodInvoke[i];
					output.add[",&"];
					x.generateMethodInvoke[new stack[]];
					output.add[",sizeof("];
    				output.add[(getChainStart[]).getCoreType[].getDeclaration[]];
    				output.add[") * "];
    				if (vs :: unknown)
    				(
    					x.getstoredtype[].getSizeIndex[0].generateCode[];
    				) else (
						x.getstoredtype[].getSize[].generateCode[];
					);
					output.add[")"];
				);
				output.add[";\n"];
				output.add["}\n"];
			//);
		);		
    	var thesizeofdata:=((getVariable[]).getstoredtype[]).getSizeIndex[0];
 		if  (thesizeofdata==null) thesizeofdata:=new Range[1,1];
 		var numberofargs;
 		var thearrayindextoread;	// for which process to read from
 		
 		if (i==null)
 		(
 			numberofargs:=0;
 			thesizeofdata:=new Range[((getVariable[]).getstoredtype[]).getSize[],((getVariable[]).getstoredtype[]).getSize[]];
 		) else (
 			numberofargs:=i.getsize[];	// number of arguments passed in i.e. g#r#t = 2
 			if (numberofargs==2) thesizeofdata:=new Range[1,1];
 		);

 		var newstack:=new stack[]; 	// for x generateMethodInvoke - called twice
 		
 		if (!(i==null))
 		(
 			thearrayindextoread:=i.top[];	// only issue top as we need the complete stack if want to call generateMethodInvoke in dynamic check below
 		);
 		
 		//if (!(i==null)) i.pop[];	// now remove the top element in the stack as no longer need the complete stack :) 		
		output.add["MPI_Bcast(&"];
		if (i==null)
		(
			(getVariable[]).generateMethodInvoke[new stack[]];
		) else (			
			(getVariable[]).generateMethodInvoke[i];			
		);
		output.add[","];

		//output.add[thesizeofdata];	// for now colour is number of elements
		if ((((getVariable[]).getstoredtype[]).getCoreType[]) :: record)
		(
			output.add["sizeof("];
			output.add[(((getVariable[]).getstoredtype[]).getCoreType[]).getRecordName[]];
			output.add[")"];
		) else (
			if (vs==1)
			(
				output.add["1"];
			) else (						
				if ((thesizeofdata.a) :: unknown)
				(
					((getVariable[]).getstoredtype[]).getSizeIndex[0].generateCode[];
				) else (
					thesizeofdata.generateCode[];
				);
			);
		);
		output.add[","];
		(((getVariable[]).getstoredtype[]).getCoreType[]).generateMPIDeclaration[];
		output.add[","];
		
		if (root.a == root.b) 
		(
			output.add[root];
		) else (
			oldroot.generateCode[];
		);
		output.add[","];
		
		if (getVariable[].isavariable[]==true)
		(
			if ((getChainStart[].getheldon[]) :: commgroup)
			(
				output.add["MESH_COMM_VAR"];
				output.add[(getChainStart[].getheldon[]).getCommId[]];
			) else (
				output.add["MPI_COMM_WORLD"];
			);
		) else (
			output.add["MPI_COMM_WORLD"];
		);		
		
		output.add[");"];				
		output.newline[];		
		//output.add["MPI_Barrier(MPI_COMM_WORLD);"];
		//output.newline[];
		misc.performCommErrorCheck[];	
		root:=oldroot;
		return true;
    };
	
	var setarg:=method[x,i]
	(			
		if (i==0) 
		(
			if ( ((x.getValue[])==null) || ((x.getValue[]) :: unknown))
			(
				root:=x;
			) else (
				if ((x.getValue[]) :: Range)
				(				
					if ((x.getValue[]).a == (x.getValue[]).b) 
					(
						root:=(x.getValue[]);
					) else (
						root:=x;
					);
				) else (
					root:=x;
				);
			);			
		);
	);
	
	var clone:=method[]
    {
    	var rety:=new broadcast[];	
    	rety.root:=root;
    	rety.alone:=alone;
    	rety.isasub:=isasub;
    	rety.declaredtype:=declaredtype;
    	rety.core:=core.clone[];    
    	return rety;
    };
    var isallocated:=method[] return 3;
	var getId:=method[] return 41;
	var getSuperTypeId:=method[] return new ArrayList[4];
	
	var valid1:=method[] 
	(
		if (!alone) (this.core.valid41[];)	
	);			
	
	var valid11:=method[] 
	(
		if (!alone) (this.core.valid41[];)	
	);
	
	var valid81:=method[] 
	(
		if (!alone) (this.core.valid41[];)	
	);
	
	var valid6:=method[] 
	(
		if (!alone) (this.core.valid41[];)	
	);
	
	var check:=method[v]
	(
		if (v::thisclass) (return true;);
		return false;
	);
);