/*
File created 2/4/2009 by Nick Brown
*/
var buffered:=class rootType
(
	var dynamic buffersize;
	var attached:=-1;

	var init:=method[]
	(
		super;	
		startroot[];		
		dependency.addinclude["<stdlib.h>"]; 
		this
	);		
	
	var display:=method[] 
	(
		print "buffered -> ";
		core.display[];
	);
	
	var getId:=method[] 421;
	
	var isBufferedCommunicationDesired:=method[] true;
	var isReadyCommunicationDesired:=method[] false;
	var isSynchronousCommunicationDesired:=method[] false;
	var clone:=method[]
    {
    	var rety:=new buffered[];	    	
    	rety.alone:=alone;
    	rety.buffersize:=buffersize;
    	rety.core:=core.clone[];
    	return rety;
    };
    
    var generateBufferAttach:=method[]
    {
    	if (buffersize==null) buffersize:=new Range[1024,1024];	// default of 1KB buffer (here none supplied by programmer)
    	if (attached==-1)
    	(    		
    		output.add["char * MESHMPIBuffer = malloc(sizeof(char) * "];
    		output.add[buffersize];
    		output.add[");\n"];    		
    	);
    	var newbsize:=buffersize;
    	if (newbsize :: Range) newbsize:=newbsize.a;
    	if (newbsize > attached)
    	(
    		if (attached > -1)
    		(
    			// need to detach old one so can resize buffer
    			output.add["{int MESHoldbsize="];
    			output.add[attached];
    			output.add[";MPI_Buffer_detach(MESHMPIBuffer,&MESHoldbsize);}"];
    		);
    		attached:=newbsize;
    		output.add["MPI_Buffer_attach(MESHMPIBuffer,"];
    		output.add[buffersize];
    		output.add[");"];
    		output.add["MESHRegisterBufferedVar(\""];
    		(getVariable[]).generateName[];
    		output.add["\\0\",&MESHMPIBuffer,"];
    		output.add[buffersize];
    		output.add[");"];
    	);
    };
    
    var generateDeclaration:=method[]
    (
    	generateBufferAttach[];
    	output.newline[];
    	return core.generateDeclaration[];
    );
    
    var setarg:=method[x,i] 
    (
    	if (i==0) buffersize:=x.getValue[];
    );
    
   var valid1:=method[] 
	(
		if (!alone) (this.core.valid412[];)	
	);	
	
	var valid11:=method[] 
	(
		if (!alone) (this.core.valid412[];)	
	);
	
	var valid6:=method[] 
	(
		if (!alone) (this.core.valid412[];)	
	);
	
	var check:=method[v]
	(
		if (v::thisclass) (return true;);
		return core.check[v];
	);	
);