/*
File created 30/1/2008 by Nick Brown
*/
var channel:=class subType
(
	var dynamic a;
	var dynamic b;
	var dynamic tag;
	var totcounter:=0;
	var init:=method[]
	(
		super;
		startroot[];
		this
	);
	
	var display:=method[] 
	(	
		print " channel ";
		print " -> ";
		core.display[];
	);
	
	var getA:=method[] a;
	var getB:=method[] b;
	
	var optimiseAccess:=method[x,i] skip;
    var optimiseAssignment:=method[x,i] dependency.addinclude["<string.h>"];    
    var generateRecv:=method[x,i]
    (
   	 	if (x.hasBeenDeclared[]==false)
 		(
 			x.generateCode[];
 			output.add[";\n"];
 		);
    	output.add["MPI_Status chanstatus"];
    	output.add[MPIstatuscnt];
    	output.add[";\n"];
    	output.add["MPI_Recv(&"];
    	x.generateMethodInvoke[new stack[]];
    	output.add[","];
    	output.add[x.getstoredtype[].getSize[]];
    	//getSizeOfData[i].generateCode[];
    	output.add[","];
		((x.getstoredtype[]).getCoreType[]).generateMPIDeclaration[];
		output.add[","];
		if (parallelgeneratecounter - 1==a.a)
		(
			output.add[b];
		) else (
			output.add[a];
		);
		output.add[","];
		if (tag==null)
		(
			output.add["2"]; // tag is 2!
		) else (
			output.add[tag];
		);
		output.add[",MPI_COMM_WORLD,&chanstatus"];
		output.add[MPIstatuscnt];
		output.add[");"];	// tag is 2!
		output.newline[];
		misc.performCommErrorCheck[];
		MPIstatuscnt:=MPIstatuscnt + 1;
		if (isallocated[]==true)
    	(
    		if (isDistributed[]==true)
    		(
    			if (getVariable[].getstoredtype[].getLocatedOn[i] == parallelgeneratecounter - 1)
    			(
    				generateDoAssn[x,i];	
    			);	
    		) else (
    			if (getheldon[]==false || getheldon[] == parallelgeneratecounter - 1)
    			(
    				generateDoAssn[x,i];	    				
    			);
    		);
    	); 
    );
    
    var generateAccess:=method[x,i] 
    { 	
    	if (parallelgeneratecounter==0)
    	(
    		if (b.a !=a.a)
    		(
    			output.add["if (myrank=="];
    			a.generateCode[];
    			output.add[")\n{\n"];
    			new basiccomm[].generateRecv[null,i,a,(getVariable[]),null];
    			output.add["}"];
    			return true;
    		);
    	);
    	if (parallelgeneratecounter - 1 != b.a) return true;
    	if (x.hasBeenDeclared[]==false) 
    	(
    		x.generateCode[];
    		output.add[";\n"];
    	);
    	if ((getChainStart[]).isAsyncCommunicationDesired[]==true)
    	(
    		new basiccomm[].generateASyncRecv[x,i,a,(getVariable[]),null,false];
    		// memcpy already added by sync command
    	) else (    		
    		new basiccomm[].generateRecv[null,i,a,(getVariable[]),null];    	
    		output.add["memcpy(&"];
    		x.generateCode[];
    		output.add[",&"];
    		(getVariable[]).generateCode[];
    		output.add[",sizeof("];
    		output.add[(getChainStart[]).getCoreType[].getDeclaration[]];
    		output.add[") * "];
    		var xSize:=getXSize[x];
			output.add[xSize];
			output.add[");"];			
		);
    	output.newline[];
		return true;
    };    
    
    var generateDoAssn:=method[x,i]
    {
    	(getVariable[]).generateMethodInvoke[i];
    	output.add["="];
    	if (x.isavariable[]==true)
    	(
    		x.generateMethodInvoke[new stack[]];
    	) else (
    		x.generateCode[];
    	);
    	output.add[";"];
    	output.newline[];
    };	
    
    var getSizeOfData:=method[i]
    {
    	var thesizeofdata:=((getVariable[]).getstoredtype[]).getSizeIndex[1];
 		if  (thesizeofdata==null) thesizeofdata:=new Range[1,1];
 		if (i==null)
 		(
 			thesizeofdata:=new Range[((getVariable[]).getstoredtype[]).getSize[],((getVariable[]).getstoredtype[]).getSize[]];
 		) else ( 		
 			if (i.getsize[]==2) thesizeofdata:=new Range[1,1];
 		);
 		return thesizeofdata;
    };
    
    var generateSend:=method[x,i]
    {
    	var alreadywrote:=false;
    	if (isallocated[]==true)
    	(
    		if (isDistributed[]==true)
    		(
    			if (getVariable[].getstoredtype[].getLocatedOn[i] == parallelgeneratecounter - 1)
    			(
    				generateDoAssn[x,i];	
    				alreadywrote:=true;
    			);	
    		) else (
    			if (getheldon[]==false || getheldon[] == parallelgeneratecounter - 1)
    			(
    				generateDoAssn[x,i];	
    				alreadywrote:=true;
    			);
    		);
    	); 
    	    		
    	if (x.isavariable[]==false && alreadywrote==false)
    	(    		
    		(x.getCurrentType[]).generateDeclaration[];
    		output.add[" tempsendvar"];
    		output.add[totcounter];
    		output.add["="];
    		x.generateCode[];
    		output.add[";\n"];
    	);		
    	output.add["MPI_Send(&"];
    	if (x.isavariable[]==false)
    	(
    		if (alreadywrote==true)
    		(
    			(getVariable[]).generateMethodInvoke[i];
    		) else (
    			output.add["tempsendvar"];
    			output.add[totcounter];
    		);
    	) else (
    		x.generateMethodInvoke[new stack[]];
    	);
    	output.add[","];
    	
    	output.add[x.getstoredtype[].getSize[]];
    	//getSizeOfData[i].generateCode[];
    	output.add[","];
    	if (x.isavariable[]==false)
    	(
    		(x.getCurrentType[]).generateMPIDeclaration[];
    	) else (
			((x.getstoredtype[]).getCoreType[]).generateMPIDeclaration[];
		);
		output.add[","];
		if (parallelgeneratecounter - 1==a.a)
		(
			output.add[b];
		) else (
			output.add[a];
		);
		output.add[","];
		if (tag==null)
		(
			output.add["2"]; // tag is 2!
		) else (
			output.add[tag];
		);
		output.add[",MPI_COMM_WORLD);"];	
		totcounter:=totcounter + 1;
		output.newline[];		
		misc.performCommErrorCheck[];
    };
    
    var overrideDefaultComm:=method[] true;
    
    var generateAssignment:=method[x,i]
    {      	 	
    	// fix with output.getselect==0;
    	var av:=a;
    	var bv:=b;
    	if (a :: Range) av:=a.a;    	
    	if (b :: Range) bv:=b.a;    	
    	if ((av == bv) && (parallelgeneratecounter - 1 == av) && (!(av :: Range)) && (!(bv :: Range)))
    	(
    		// local copy!
    		return core.generateAssignment[x,i];    		
    	);    	 	
    	var acheck:=null;
    	if (!(a :: Range)) acheck:=a.getValue[];
    	
    	var bcheck:=null;
	    if (!(b :: Range)) bcheck:=b.getValue[];
    	
    	if ((parallelgeneratecounter==0) && ( (!(((acheck) :: unknown))) && (!(acheck :: Range))) && ( (!(((bcheck) :: unknown))) && (!(bcheck :: Range))))
    	(
    		output.add["if (myrank=="];
    		a.generateCode[];
    		output.add[")\n{\n"];
    		if (a==b)
    		(
    			output.add["memcpy(&"];
    			(getVariable[]).generateMethodInvoke[i];
    			output.add[",&"];
    			x.generateMethodInvoke[new stack[]];
    			output.add[",sizeof("];
    			output.add[(getChainStart[]).getCoreType[].getDeclaration[]];
    			output.add[") * "];
    			var xSize:=getXSize[x];
				output.add[xSize];
				output.add[");\n"];
    		) else (
    			var amargs:=new stack[];
    			x.retrieveMethodArgs[amargs];
    			new basiccomm[].generateSend[x,amargs,b,x,null,null];  		    		    
    			output.add["}\n"];
    			output.add["if (myrank=="];
    			b.generateCode[];
    			output.add[")\n{\n"];
    			new basiccomm[].generateRecv[null,i,a,(getVariable[]),null];
    			output.add["}"];
    		);    		
    	);
    	
    	if ((((acheck) :: unknown)) || (acheck :: Range))
    	(
    		output.add["if (myrank=="];
    		a.generateCode[];
    		output.add[")\n{\n"];
    		/*
    		output.add["if ("];
    		i.top[].generateCode[];
    		output.add["!="];
    		b.generateCode[];
    		output.add["){MESHErrorBlockNumNotOnRecvProcess();}\n"];
    		*/
    		output.add["if ("];
    		a.generateCode[];
    		output.add["=="];
    		b.generateCode[];
    		output.add["){\n"];
    		output.add["memcpy(&"];
    		(getVariable[]).generateMethodInvoke[i];
    		output.add[",&"];
    		x.generateMethodInvoke[new stack[]];
    		output.add[",sizeof("];
    		output.add[(getChainStart[]).getCoreType[].getDeclaration[]];
    		output.add[") * "];
    		xSize:=getXSize[x];
			output.add[xSize];
    		output.add[");\n} else {\n"];
    		var margs:=new stack[];
    		x.retrieveMethodArgs[margs];
    		new basiccomm[].generateSend[x,margs,b,x,null,null];  		    		    
    		output.add["}}\n"];
    		output.add["if (myrank=="];
    		b.generateCode[];
    		output.add[")\n{\n if ("];
    		a.generateCode[];
    		output.add["!="];
    		b.generateCode[];
    		output.add["){"];
    		new basiccomm[].generateRecv[null,i,a,(getVariable[]),null];
    		output.add["}}"];
    	) else (    		
    		if (parallelgeneratecounter - 1 == av)
    		(    			
    			if (!((getChainStart[]).getPartition[]==null))
    			(
    			// need to check that block number corresponds to reciever      			
    				var dynamicneeded:=false;
    				if ((i.top[].getValue[]) :: Range)
    				(
    					if ( (i.top[].getValue[]).a != (i.top[].getValue[]).b) dynamicneeded:=true;
    				);
    				
    				if (!(b :: Range))    				    				
    				(    					
    					if ((b.getValue[]) :: unknown)
    					(
    						dynamicneeded:=true;
    					) else (
    						if (((b.getValue[]).a) != ((b.getValue[]).b)) dynamicneeded:=true;
    					);
    				);
    				
    				if ((!(((i.top[]).getValue[]) :: unknown)) && (dynamicneeded==false)) 
    				(
    					if ((((((getChainStart[]).getPartition[]).getBlocks[]).aget[(i.top[]).getValue[].a]).getWhichProcessOn[] != bv) && (b :: Range))
    					(
    						throw error "The receiver defined in the channel must be the same as the process the block is on";
    					);
    				) else (
    					// need dynamic analysis code!
    					var nodo:=false;
    					if  (((i.top[]).isavariable[]==true) && (b.isavariable[]==true)) if (!(i.top[].getName[] = b.getName[])) nodo:=true;
    					if (nodo==false)
    					(
    						output.add["if ("];
    						i.top[].generateCode[];
    						output.add["!="];
    						b.generateCode[];
    						output.add["){MESHErrorBlockNumNotOnRecvProcess();}\n"];
    					);
    				);    				    				
    			) else (
    				if ((getChainStart[].getheldon[] != false ) && (!(getChainStart[].getheldon[] == null )) && (b :: Range))
    				(    					
    					if ((getChainStart[].getheldon[]) :: commgroup)
    					(
    						if ((getChainStart[].getheldon[]).isWithin[bv] ==false)
    						(
								throw error "Variable must be on receiver";    						
    						);
    					) else (
    						if ((getChainStart[].getheldon[]).getValue[].a != bv)
    						(
								throw error "Variable must be on receiver";    						
    						);
    					);
    				);
    			);
    			if (x.isavariable[]==true)
    			(
    				if ((i==null) && (!(x.getstoredtype[].getheldon[] == null)) && (!((x.getstoredtype[].getheldon[]) == false)))
    				(    				    				
    					if ((x.getstoredtype[].getheldon[]) :: commgroup)
    					(    					
    						if ((x.getstoredtype[].getheldon[]).isWithin[av] ==false)
    						(
								throw error "Variable must be on sender";    						
    						);
    					) else (
    						if ((x.getstoredtype[].getheldon[]).getValue[].a != av)
    						(
								throw error "Variable must be on sender";    						
    						);
    					);
    				);
    			);
    			
    			margs:=new stack[];    			
    			if (x.isavariable[]) x.retrieveMethodArgs[margs];
    			bcheck:=null;
	    		if (!(b :: Range)) bcheck:=b.getValue[];
	    		var dodynamic:=false;
    			if ((((bcheck) :: unknown)) || (bcheck :: Range))
    			(
    				dodynamic:=true;
    				// need to generate dynamic check for memcpy or send
    				output.add["if ("];
    				b.generateCode[];
    				output.add["=="];
    				a.generateCode[];
    				output.add[")\n{\n"];
    				output.add["memcpy(&"];
    				(getVariable[]).generateMethodInvoke[i];
    				output.add[",&"];
    				x.generateMethodInvoke[new stack[]];
    				output.add[",sizeof("];
    				output.add[(getChainStart[]).getCoreType[].getDeclaration[]];
    				output.add[") * "];
    				xSize:=getXSize[x];
					output.add[xSize];
					output.add[");\n} else {\n"];
    			);
    			if ((getChainStart[]).isAsyncCommunicationDesired[]==true)
    			(
    				new basiccomm[].generateASyncSend[x,margs,b,(getVariable[])];
    			) else (    				
    				if ((getChainStart[]).isBufferedCommunicationDesired[]==true)
    				(
	    				new basiccomm[].generateBufferedSend[x,margs,b,(getVariable[])];    				
    				) else (
    					if ((getChainStart[]).isReadyCommunicationDesired[]==true)
    					(
	    					new basiccomm[].generateReadySend[x,margs,b,(getVariable[])];    				
    					) else (
    						if ((getChainStart[]).isSynchronousCommunicationDesired[]==true)
    						(
    							new basiccomm[].generateSyncSend[x,margs,b,(getVariable[])];    				
    						) else (
    							new basiccomm[].generateSend[x,margs,b,(getVariable[]),null,null];    				
    						);
    					);
    				);
    			);
    			if (dodynamic==true) output.add["}"];
    		);
    	);
    	/*
    	bcheck:=null;
    	if (!(b :: Range)) bcheck:=b.getValue[];
    	if ((((bcheck) :: unknown)) || (bcheck :: Range))
    	(
    		// might be anything!
    		output.add["if (myrank=="];
    		b.generateCode[];
    		output.add[")\n{\n"]; 
    		output.add["if ("];
    		a.generateCode[];
    		output.add["!="];
    		b.generateCode[];   		
    		output.add[")\n{\n"];
    		new basiccomm[].generateRecv[null,i,a,(getVariable[]),null];    		    		    
    		output.add["}}\n"];
    	) else (    	
    		if (parallelgeneratecounter - 1 == bv)
    		(
    			new basiccomm[].generateRecv[null,i,a,(getVariable[]),null];
    		);    	
    	);
    	*/
		return true;
    };
    
    var getXSize:=method[x]
    {
    	var xSize:=(x.getstoredtype[]).getSize[].a;
    	var xType:=x.getstoredtype[];
		if (x.retrieveMethodArgs[new stack[]].getsize[] > 0)
		(
			var xstack:=x.retrieveMethodArgs[new stack[]];
			xSize:=1;
			if (xstack.getsize[] ==xType.getDimensions[])
			(
				xSize:=1;
			) else (
				for j from 0 to xstack.getsize[] - 1
				(					
					xSize:=xSize * xType.getSizeIndex[(xstack.getsize[] - j)].a;						
				);
			);
		);
		return xSize;
    };
	
	var setarg:=method[x,i]
	(			
		if (i==0) 
		(
			tag:=null;
			if ( ((x.getValue[])==null) || ((x.getValue[]) :: unknown))
			(
				a:=x;
			) else (
				if ((x.getValue[]) :: Range)
				(
					if ((x.getValue[]).a==(x.getValue[]).b) 
					(
						a:=(x.getValue[]);
					) else (
					 	a:=x;
					);
				) else (
					a:=(x.getValue[]);
				);
			);			
		);
		
		if (i==1) 
		(
			if ( ((x.getValue[])==null) || ((x.getValue[]) :: unknown))
			(
				b:=x;
			) else (
				if ((x.getValue[]) :: Range)
				(
					if ((x.getValue[]).a==(x.getValue[]).b) 
					(
						b:=(x.getValue[]);
					) else (
					 	b:=x;
					);
				) else (
					b:=(x.getValue[]);
				);
			);			
		);
		
		if (i==2) 
		(
			if ( ((x.getValue[])==null) || ((x.getValue[]) :: unknown))
			(
				tag:=x;
			) else (
				tag:=(x.getValue[]);
			);			
		);
	);
	
	var clone:=method[]
    {
    	var rety:=new channel[];	
    	rety.b:=b;
    	rety.a:=a;
    	rety.tag:=tag;
    	rety.alone:=alone;
    	rety.core:=core.clone[];    
    	return rety;
    };
	
	var getId:=method[] return 42;
	var getSuperTypeId:=method[] return new ArrayList[4];
	
	var valid1:=method[] 
	(
		if (!alone) (this.core.valid42[];)	
	);	
	
	var valid11:=method[] 
	(
		if (!alone) (this.core.valid42[];)	
	);
	
	var valid6:=method[] 
	(
		if (!alone) (this.core.valid42[];)	
	);
	
	var check:=method[v]
	(
		if (v::thisclass) (return true;);
		return false;
	);
);