/*
File created 25/9/2008 by Nick Brown
*/
var gadgetparamfile:=class rootType
(		
	var dynamic filename;
	var dynamic donedeclaration:=false;
	var display:=method[] 
	(
		print "gadgetparamfile -> ";
		core.display[];
	);
	
	var init:=method[]
	(
		dependency.addinclude["<meshamgadget.h>"];
		super;
		startroot[];
		this
	);
	
	var generateCode:=method[]
	(
		if (donedeclaration==false)
		{
			donedeclaration:=true;
			output.clearline[];
			output.newline[];
			output.add["MESHGADregisterparamfile("];
			filename.generateCode[];
			output.add[",\""];
			(getVariable[]).generateName[];
			output.add["\\0\""];
			output.add[")"];
			scopeinfo.addVar[(getVariable[])];
		};
	);
	
	var destroy:=method[]
	(
		output.add["MESHGADfreeparamfile(\""];
		(getVariable[]).generateName[];
		output.add["\\0\");"];
		output.newline[];
	);
	
	var generateDotCode:=method[x]
	{
		var thetype:=getKeywordType[x];
		if (thetype.getTypeID[] == 1) output.add["*(int *)"];
		if (thetype.getTypeID[] == 3) output.add["*(double *)"];
		output.add["MESHGADgetparamvalue(\""];
		output.add[x];
		output.add["\\0\",\""];
		(getVariable[]).generateName[];
		output.add["\\0\")"];
	};
	
	var generateAccess:=method[x,i]
	{		
		if (generateassignmentvalue==true) return false;
		var thetype:=getKeywordType[dotstr];
		if (thetype==null) return false;	// if invalid keyword dont continue!		
		x.generateCode[];			
		output.add["="];
		if (thetype.getTypeID[] == 1) output.add["*(int *)"];
		if (thetype.getTypeID[] == 3) output.add["*(double *)"];
		output.add["MESHGADgetparamvalue(\""];
		output.add[dotstr];
		output.add["\\0\",\""];
		(getVariable[]).generateName[];
		output.add["\\0\");"];
		output.newline[];
		//output.ignoretillnewline[];
		return true;
	};
	
	var generateAssignment:=method[x,i]
	{		
		if (dotstr="")
		(
			// no dot args - which is ok :)
			output.add["MESHGADcopyparamvalues(\""];
			(getVariable[]).generateName[];
			output.add["\\0\",\""];
			x.generateCode[];
			output.add["\\0\");"];
			output.newline[];
			//output.ignoretillnewline[];
			return true;			
		);
		
		var thetype:=getKeywordType[dotstr];
		if (thetype==null) return false;	// if invalid keyword dont continue!
		if (thetype.check[String])
		(
			output.add["MESHGADputparamvalue(\""];
			output.add[dotstr];
			output.add["\\0\","];
			x.generateCode[];
			output.add[",\""];
			(getVariable[]).generateName[];
			output.add["\\0\");"];
			output.ignoretillnewline[];
		) else (		
			if (x.isavariable[]==false)
			(
				if (thetype.getTypeID[]==1)
				(
					output.add["{int MESHGADtemp="];
				) else (
					output.add["{double MESHGADtemp="];
				);
				x.generateCode[];
				output.add[";\n"];
			);
			output.add["MESHGADputparamvalue(\""];
			output.add[dotstr];
			output.add["\\0\",&"];
			if (x.isavariable[]==false)
			(
				output.add["MESHGADtemp"];			
			) else (
				x.generateCode[];
			);
			output.add[",\""];
			(getVariable[]).generateName[];
			output.add["\\0\");"];
			if (x.isavariable[]==false) output.add["}"];
			output.ignoretillnewline[];			
		);	
		return true;
	};
		
	var getDotValue:=method[x,i]
	(
		return new unknown[];
	);
	
	var getdottype:=method[thestring]
	(
	 	return getKeywordType[thestring];
	);
	
	var getKeywordType:=method[thestring]
	(
		if (thestring="OutputDir") return String;
		if (thestring="InitCondFile") return String;
		if (thestring="OutputDir") return String;
		if (thestring="SnapshotFileBase") return String;
		if (thestring="EnergyFile") return String;
		if (thestring="CpuFile") return String;
		if (thestring="InfoFile") return String;
		if (thestring="TimingsFile") return String;
		if (thestring="RestartFile") return String;
		if (thestring="ResubmitCommand") return String;
		if (thestring="OutputListFilename") return String;
		if (thestring="OutputListOn") return Int;
		if (thestring="Omega0") return Doublee;
		if (thestring="OmegaBaryon") return Doublee;
		if (thestring="OmegaLambda") return Doublee;
		if (thestring="HubbleParam") return Doublee;
		if (thestring="BoxSize") return Doublee;
		if (thestring="PeriodicBoundariesOn") return Int;
		if (thestring="TimeOfFirstSnapshot") return Doublee;
		if (thestring="CpuTimeBetRestartFile") return Doublee;
		if (thestring="TimeBetStatistics") return Doublee;
		if (thestring="TimeBegin") return Doublee;
		if (thestring="TimeMax") return Doublee;
		if (thestring="TimeBetSnapshot") return Doublee;
		if (thestring="UnitVelocity_in_cm_per_s") return Doublee;
		if (thestring="UnitLength_in_cm") return Doublee;
		if (thestring="UnitMass_in_g") return Doublee;
		if (thestring="TreeDomainUpdateFrequency") return Doublee;
		if (thestring="ErrTolIntAccuracy") return Doublee;
		if (thestring="ErrTolTheta") return Doublee;
		if (thestring="ErrTolForceAcc") return Doublee;
		if (thestring="MinGasHsmlFractional") return Doublee;
		if (thestring="MaxSizeTimestep") return Doublee;
		if (thestring="MinSizeTimestep") return Doublee;
		if (thestring="MaxRMSDisplacementFac") return Doublee;
		if (thestring="ArtBulkViscConst") return Doublee;
		if (thestring="CourantFac") return Doublee;
		if (thestring="DesNumNgb") return Doublee;
		if (thestring="MaxNumNgbDeviation") return Doublee;
		if (thestring="ComovingIntegrationOn") return Int;
		if (thestring="ICFormat") return Int;
		if (thestring="SnapFormat") return Int;
		if (thestring="NumFilesPerSnapshot") return Int;
		if (thestring="NumFilesWrittenInParallel") return Int;
		if (thestring="ResubmitOn") return Int;
		if (thestring="TypeOfTimestepCriterion") return Int;
		if (thestring="TypeOfOpeningCriterion") return Int;
		if (thestring="TimeLimitCPU") return Doublee;
		if (thestring="SofteningHalo") return Doublee;
		if (thestring="SofteningDisk") return Doublee;
		if (thestring="SofteningBulge") return Doublee;
		if (thestring="SofteningGas") return Doublee;
		if (thestring="SofteningStars") return Doublee;
		if (thestring="SofteningBndry") return Doublee;
		if (thestring="SofteningHaloMaxPhys") return Doublee;
		if (thestring="SofteningDiskMaxPhys") return Doublee;
		if (thestring="SofteningBulgeMaxPhys") return Doublee;
		if (thestring="SofteningGasMaxPhys") return Doublee;
		if (thestring="SofteningStarsMaxPhys") return Doublee;
		if (thestring="SofteningBndryMaxPhys") return Doublee;
		if (thestring="BufferSize") return Int;
		if (thestring="PartAllocFactor") return Doublee;
		if (thestring="TreeAllocFactor") return Doublee;
		if (thestring="GravityConstantInternal") return Doublee;
		if (thestring="InitGasTemp") return Doublee;
		if (thestring="MinGasTemp") return Doublee;
		if (thestring="OutputListLength") return Int;
		return null;
	);
	
	var setDotValue:=method[x,i]
	(
		skip;
	);
	
	var generateDeclaration:=method[]
	(
		output.add["void *"];
	);	
	
	var clone:=method[]
    {
    	var rety:=new gadgetparamfile[];	    	
    	rety.alone:=alone;
    	rety.donedeclaration:=donedeclaration;
    	rety.filename:=filename;
    	rety.core:=core.clone[];
    	return rety;
    };
			
	var setarg:=method[x,i]
	(
		if (i==0) filename:=x;
	);		
	
	var valid0:=method[] 
	(
		if (!alone) (core.valid1[];)	
	);	
		
	var check:=method[v]
	(
		if (v::thisclass) (return true;);
		return core.check[v];
	);
);