/*
File created 30/9/2008 by Nick Brown
*/

var onesided:=class rootType
(		
	var totcounter:=0;
	var sender;
	var receiver;
	var init:=method[]
	(
		super;
		startroot[];
		dependency.addinclude["<string.h>"];
		this
	);	
	
	var display:=method[] 
	(	
		print " onesided ";
		print " -> ";
		core.display[];
	);
	
	var setarg:=method[x,i]
	(
		//(getVariable[]).setGenMPIWindow[true];
		if (i==0) sender:=x;
		if (i==1) receiver:=x;
		if (i > 1)
		(
			errors.STypeAError[];
		);
	);
	//var getCoreType:=method[] return new Int;
	var optimiseAssignment:=method[x,i]
	(
		(getVariable[]).setGenMPIWindow[true];
		checkDataAllocation[];	// fix - where a:=b, check receiver has a and sender b
	);
	
	var checkDataAllocation:=method[]
	{
		if (!(sender==null))
		(
			if ((!((getChainStart[]).getheldon[] == null)) && (!((getChainStart[]).getheldon[] == false)))
			(	
				if (((getChainStart[]).getheldon[]) :: commgroup)
				(
					if (((getChainStart[]).getheldon[]).isWithin[sender.getValue[].a]==false)
					(
						throw error "For onesided communication data must be allocated on explicit sender";
					);
				) else (				
					var dheld:=((getChainStart[]).getheldon[]);
					if (dheld :: Range) dheld:=dheld.a;
					if (dheld != sender.getValue[].a)
					(
						throw error "For onesided communication data must be allocated on explicit sender";
					);
				);
			);
		);
		
		if (!(receiver==null))
		(
			if ((!((getChainStart[]).getheldon[] == null)) && (!((getChainStart[]).getheldon[] == false)))
			(	
				if (((getChainStart[]).getheldon[]) :: commgroup)
				(
					if (((getChainStart[]).getheldon[]).isWithin[receiver.getValue[].a]==false)
					(
						throw error "For onesided communication data must be allocated on explicit receiver";
					);
				) else (				
					dheld:=((getChainStart[]).getheldon[]);
					if (dheld :: Range) dheld:=dheld.a;
					if (dheld != receiver.getValue[].a)
					(
						throw error "For onesided communication data must be allocated on explicit receiver";
					);
				);
			);
		);
	};
	
	var optimiseAccess:=method[x,i]
	(
		(getVariable[]).setGenMPIWindow[true];		
	);
	
	var performCSwitchandPut:=method[pid,x,i,t,f,m]
	{
		var oldp:=output.getSelect[];
		if (oldp == 0)
		(
			output.setPSelect[pid];
		);
		if (output.getSelect[] == pid) generateOnesidedPut[x,i,t,f,m];
		if (oldp == 0)
		(
			output.setSelect[oldp];				
		);
	};
	
	var performCSwitchandGet:=method[pid,x,i,t,f,m]
	{
		var oldp:=output.getSelect[];
		if (oldp == 0)
		(
			output.setPSelect[pid];
		);
		if (output.getSelect[] == pid) generateOnesidedGet[x,i,t,f,m];
		if (oldp == 0)
		(
			output.setSelect[oldp];				
		);
	};
	
	var generateMemcpy:=method[x,i,v]
	{
		output.add["memcpy(&"];
		v.generateMethodInvoke[i];
		output.add[",&"];
		x.generateMethodInvoke[new stack[]];
		output.add[",sizeof("];
		output.add[x.getstoredtype[].getCoreType[].getDeclaration[]];
		output.add[") * "];
		output.add[x.getstoredtype[].getCoreType[].getSize[].a];
		output.add[");"];
		output.newline[];
	};
	
	var performCSwitchandMemcpy:=method[pid,x,i,v]
	{
		var oldp:=output.getSelect[];
		if (oldp == 0)
		(
			output.setPSelect[pid];
		);
		if (output.getSelect[] == pid) 
		(
			generateMemcpy[x,i,v];
		);
		if (oldp == 0)
		(
			output.setSelect[oldp];				
		);
	};
	
	var overrideDefaultComm:=method[] true;
	
	var generateAssignment:=method[x,i]
	{
		if ((!(sender ==null)) && (!(receiver ==null)))
		(
			performCSwitchandPut[sender.getValue[].a + 1,x,i,sender.getValue[],receiver.getValue[],(getVariable[])];
			addSyncWindow[(getVariable[])];
			return true;
		) else (
			if ((!(getChainStart[].getheldon[] == null )))
			(			
				if (((getChainStart[].getheldon[]) :: commgroup) || (getChainStart[].getheldon[] == false ))
				(
					// here a:=b, a is a communication group / multiple allocation
					if ((!(x.getstoredtype[].getheldon[] == null )))
					(
						if (((x.getstoredtype[].getheldon[]) :: commgroup) || (x.getstoredtype[].getheldon[] == false ))
						(
							// a:=b, b is comm group/multiple allocation
							return core.generateAssignment[x,i];
						) else (				
							// a:=b, b is singly allocated
							// DEPENDS ON CR
							var ii:=0;
							var oldp:=output.getSelect[];
							if (oldp == 0)
							(
								output.setPSelect[(x.getstoredtype[]).getheldon[].getValue[].a + 1];
							);
							for ii from 0 to totalprocesses - 1
							(
								var passstage:=false;
								if ((getChainStart[].getheldon[]) :: commgroup) if ((getChainStart[].getheldon[]).isWithin[ii]==true) passstage:=true;
								if (((getChainStart[].getheldon[]) == false) || (passstage==true))
								(							
									if (((x.getstoredtype[]).getheldon[]) != ii)
									(
										// if a is single, and is NOT located on ith process then results in get data from that process								
										if (output.getSelect[] == (x.getstoredtype[]).getheldon[].getValue[].a + 1) generateOnesidedPut[x,i,((x.getstoredtype[]).getheldon[]).getValue[],new Range[ii,ii],(getVariable[])];
									) else (
										// if a is single and IS located on ith process then generate assignment
										if (output.getSelect[] == (x.getstoredtype[]).getheldon[].getValue[].a + 1) generateMemcpy[x,i,(getVariable[])];
									);
								);
							);
							if (oldp == 0)
							(
								output.setSelect[oldp];				
							);
							addSyncWindow[(getVariable[])];
						);						
					);
				) else (				
					// a:=b, a is singly allocated	
					if ((!(x.getstoredtype[].getheldon[] == null )))
					(
						if (((x.getstoredtype[].getheldon[]) :: commgroup) || (x.getstoredtype[].getheldon[] == false ))
						(
							// b is multiple / commgroup
							// DEPENDS ON CW
							return core.generateAssignment[x,i];
						) else (				
							if ((x.getstoredtype[].getheldon[]) == (getChainStart[].getheldon[])) return core.generateAssignment[x,i];	// just do a local assignment - pass this to the rest of the types to handle this
							performCSwitchandPut[((x.getstoredtype[]).getheldon[]) + 1,x,i,x.getstoredtype[].getheldon[].getValue[],getChainStart[].getheldon[].getValue[],(getVariable[])];							
							addSyncWindow[(getVariable[])];
						);
					);
				);
				return true;
			);
		);
	};
	
	var addSyncWindow:=method[v]
	{
		output.add["MESHRegisterOneSidedWindow(&MESHwinvar"];
		v.generateName[];
		output.add[",\""];
		v.generateName[];
		output.add["\\0\");"];
		output.newline[];		
		misc.addASyncVar[v];
	};
	
	var generateAccess:=method[x,i]
	{
		if ((!(sender ==null)) && (!(receiver ==null)))
		(
			performCSwitchandGet[receiver.getValue[].a + 1,x,i,sender.getValue[],receiver.getValue[],(getVariable[])];
			addSyncWindow[(getVariable[])];	
			return true;
		) else (
			if ((!(getChainStart[].getheldon[] == null )))
			(			
				if (((getChainStart[].getheldon[]) :: commgroup) || (getChainStart[].getheldon[] == false ))
				(
					// here a:=b, a is a communication group / multiple allocation
					if ((!(x.getstoredtype[].getheldon[] == null )))
					(
						if (((x.getstoredtype[].getheldon[]) :: commgroup) || (x.getstoredtype[].getheldon[] == false ))
						(
							// a:=b, b is comm group/multiple allocation
							var jj:=0;
							for jj from 0 to totalprocesses - 1
							(
								var tpassstage:=false;
								if ((x.getstoredtype[].getheldon[]) :: commgroup) if ((x.getstoredtype[].getheldon[]).isWithin[jj]==true) tpassstage:=true;
								var opassstage:=false;
								if ((getChainStart[].getheldon[]) :: commgroup) if ((getChainStart[].getheldon[]).isWithin[jj]==true) opassstage:=true;

								if (((x.getstoredtype[].getheldon[] == false) || (tpassstage==true)) && ((getChainStart[].getheldon[] == false) || (opassstage==true)))
								(							
									performCSwitchandMemcpy[jj + 1,(getVariable[]),i,x];
								);
							);
						) else (				
							// a:=b, a is singly allocated
							// DEPENDS ON CW
							performCSwitchandMemcpy[(x.getstoredtype[].getheldon[]) + 1,(getVariable[]),i,x];
						);			
						addSyncWindow[(getVariable[])];			
					);
				) else (				
					// a:=b, b is singly allocated	
					if ((!(x.getstoredtype[].getheldon[] == null )))
					(
						if (((x.getstoredtype[].getheldon[]) :: commgroup) || (x.getstoredtype[].getheldon[] == false ))
						(
							// a is multiple / commgroup
							// DEPENDS ON CR
							var ii:=0;
							for ii from 0 to totalprocesses - 1
							(
								var passstage:=false;
								if ((x.getstoredtype[].getheldon[]) :: commgroup) if ((x.getstoredtype[].getheldon[]).isWithin[ii]==true) passstage:=true;
								
								if ((x.getstoredtype[].getheldon[] == false) || (passstage==true))
								(							
									if (((getChainStart[]).getheldon[]) != ii)
									(
										// if a is single, and is NOT located on ith process then results in get
										performCSwitchandGet[ii + 1,x,i,getChainStart[].getheldon[].getValue[],false,(getVariable[])];
									) else (
										// if a is single and IS located on ith process then generate assignment
										performCSwitchandMemcpy[ii + 1,(getVariable[]),i,x];
									);
								);
							);
							addSyncWindow[(getVariable[])];			
						) else (				
							if ((x.getstoredtype[].getheldon[]) == (getChainStart[].getheldon[])) return core.generateAccess[x,i];	// just do a local assignment - pass this to the rest of the types to handle this
							performCSwitchandGet[(x.getstoredtype[].getheldon[]) + 1,x,i,getChainStart[].getheldon[].getValue[],x.getstoredtype[].getheldon[].getValue[],(getVariable[])];
							addSyncWindow[(getVariable[])];			
						);
					);
				);
				return true;
			);
		);
	};
	
	var generateWindowCode:=method[v,heldhere]
	(
		output.add["MPI_Win MESHwinvar"];
		v.generateName[];
		output.add[";"];
		output.newline[];
		output.add["MPI_Win_create("];
		if (heldhere==true)
		(
			output.add["&"];
			v.generateName[];
		) else (
			output.add["NULL"];
		);
		output.add[","];
		if (heldhere==true)
		(
			output.add[v.getstoredtype[].getCoreType[].getSize[].a];
		) else (
			output.add["0"];
		);
		output.add[", sizeof("];
		output.add[v.getstoredtype[].getCoreType[].getDeclaration[]];
		output.add["), MPI_INFO_NULL,"];
		//if ((v.getstoredtype[].getheldon[]) :: commgroup)
		//(
		//	(v.getstoredtype[].getheldon[]).generateCommName[];
		//) else (
			output.add["MPI_COMM_WORLD"];
		//);
		output.add[", &MESHwinvar"];
		v.generateName[];
		output.add[");"];
		scopeinfo.addVar[v];
		output.newline[];
		addSyncWindow[v];
	);
	
	var generateWindow:=method[v]
	{
		if ((!((v.getstoredtype[]).getheldon[]==null)) && (!((v.getstoredtype[]).getheldon[]==false)))
		(		
			var oldout:=output.getSelect[];
			var num:=(v.getstoredtype[]).getheldon[];
			if (!(num :: commgroup)) num:=num.getValue[];
			if (oldout==0) // general
			(
				var i:=0;
				for i from 0 to totalprocesses - 1
				(											
					if (num :: Range) 
					(
						output.setPSelect[i + 1];
						if (i==num.a)
						(																					
							generateWindowCode[v,true];							
						) else (
							generateWindowCode[v,false];							
						);
						output.setSelect[oldout];																							
					);
					if (num :: commgroup) 
					(
						output.setPSelect[i + 1];
						if (num.isWithin[i]==true)
						(			
							// for multiple on a commgroup											
							generateWindowCode[v,true];							
						) else (
							generateWindowCode[v,false];							
						);
						output.setSelect[oldout];
					);
				);
				if (output.getSelect[] !=oldout) output.setSelect[oldout];
			);	
		) else (
			generateWindowCode[v,true];			
		);
	};
	
	//var destroy:=method[] destroyWin[(getVariable[])];
	
	var generateDestroyCode:=method[v]
	(
		output.add["MPI_Win_free(&MESHwinvar"];
		v.generateName[];
		output.add[");"];
		output.newline[];
	);
	
	var destroyWin:=method[v]
	{
		if ((!((v.getstoredtype[]).getheldon[]==null)) && (!((v.getstoredtype[]).getheldon[]==false)))
		(		
			var oldout:=output.getSelect[];
			var num:=(v.getstoredtype[]).getheldon[];
			if (!(num :: commgroup)) num:=num.getValue[];
			if (oldout==0) // general
			(
				var i:=0;
				for i from 0 to totalprocesses - 1
				(											
					if (num :: Range) 
					(
						//if (i==num.a)
						//(														
							output.setPSelect[i + 1];
							generateDestroyCode[v];																							
							output.setSelect[oldout];
						//);
					);
					if (num :: commgroup) 
					(
						//if (num.isWithin[i]==true)
						//(			
							// for multiple on a commgroup				
							output.setPSelect[i + 1];
							generateDestroyCode[v];
							output.setSelect[oldout];
						//);
					);
				);
				if (output.getSelect[] !=oldout) output.setSelect[oldout];
			);	
		) else (
			generateDestroyCode[v];
		);		
	};
		
	var getSizeOfData:=method[i]
    {
    	var thesizeofdata:=((getVariable[]).getstoredtype[]).getSizeIndex[1];
 		if  (thesizeofdata==null) thesizeofdata:=new Range[1,1];
 		if (i==null)
 		(
 			thesizeofdata:=new Range[((getVariable[]).getstoredtype[]).getSize[],((getVariable[]).getstoredtype[]).getSize[]];
 		) else ( 		
 			if (i.getsize[]==2) thesizeofdata:=new Range[1,1];
 		);
 		return thesizeofdata;
    };
    
    var isOneSidedCommunicationDesired:=method[] true;
    
    var generateOnesidedGet:=method[variable,index,fromp,topr,srcwin]
    (
    	output.add["MPI_Win_lock(MPI_LOCK_SHARED ,"];
    	fromp.generateCode[];
    	output.add[", 0, MESHwinvar"];
    	(srcwin).generateName[];
    	output.add[");"];
    	output.newline[];
    	output.add["MPI_Get(&"];
    	variable.generateMethodInvoke[index];
    	output.add[","];
    	output.add[variable.getstoredtype[].getCoreType[].getSize[].a];
    	output.add[","];
    	variable.getstoredtype[].getCoreType[].generateMPIDeclaration[];
    	output.add[","];
    	fromp.generateCode[];
    	output.add[",0,"];
    	output.add[variable.getstoredtype[].getCoreType[].getSize[].a];
    	output.add[","];
    	variable.getstoredtype[].getCoreType[].generateMPIDeclaration[];
    	output.add[",MESHwinvar"];
    	(srcwin).generateName[];
    	output.add[");"];    	
    	output.newline[];
    	output.add["MPI_Win_unlock("];
    	fromp.generateCode[];
    	output.add[", MESHwinvar"];
    	(srcwin).generateName[];
    	output.add[");"];
    	output.newline[];
    );
    
    var generateOnesidedPut:=method[variable,index,fromp,topr,srcwin]
    (
    	output.add["MPI_Win_lock(MPI_LOCK_EXCLUSIVE ,"];
    	topr.generateCode[];
    	output.add[", 0,MESHwinvar"];
    	(srcwin).generateName[];
    	output.add[");"];
    	output.newline[];
    	output.add["MPI_Put(&"];    	
    	variable.generateMethodInvoke[index];
    	output.add[","];
    	output.add[variable.getstoredtype[].getCoreType[].getSize[].a];
    	output.add[","];
    	variable.getstoredtype[].getCoreType[].generateMPIDeclaration[];
    	output.add[","];
    	topr.generateCode[];
    	output.add[",0,"];
    	output.add[variable.getstoredtype[].getCoreType[].getSize[].a];
    	output.add[","];
    	variable.getstoredtype[].getCoreType[].generateMPIDeclaration[];
    	output.add[",MESHwinvar"];
    	(srcwin).generateName[];
    	output.add[");"];    	
    	output.newline[];
    	output.add["MPI_Win_unlock("];
    	topr.generateCode[];
    	output.add[", MESHwinvar"];
    	(srcwin).generateName[];
    	output.add[");"];
    	output.newline[];
    );			
		
	//var getReturnType:=method[] return core.getTy[];
	
	var valid1:=method[] 
	(
		if (!alone) (this.core.valid422[];)	
	);	
	
	var valid11:=method[] 
	(
		if (!alone) (this.core.valid422[];)	
	);
	
	var valid6:=method[] 
	(
		if (!alone) (this.core.valid422[];)	
	);
	
	var check:=method[v]
	{
		if (v::thisclass) (return true;);
		if (v.check[Null]) return false;
		return true;
	};
	
		
	var clone:=method[]
    {
    	var rety:=new onesided[];	    	
    	rety.alone:=alone;
    	rety.core:=core.clone[];    
    	return rety;
    };
);