/*
File created 15/10/2008 by Nick Brown
*/
var particletype:=class rootType
(		
	var dynamic donedeclaration:=false;
	var dynamic iamencapsulated:=false;
	var display:=method[] 
	(
		print "particle -> ";
		core.display[];
	);
	
	var init:=method[]
	(		
		dependency.addinclude["<meshamgadget.h>"];
		super;
		startroot[];
		this
	);	
	
	var generateCode:=method[]
	(
		//output.add["malloc(sizeof(MESHGADparticle));"];
		output.newline[];
		return true;
	);
	
	var getCoreType:=method[] this;
	
	var destroy:=method[]
	(
		skip;
	);
	

	var generateDotCode:=method[x]
	{				
		(getVariable[]).generateName[];		
		generateDotElement[x];
	};	
	
	var generateDotElement:=method[x]
	(
		output.add["."];
		if (x="position") output.add["Pos"];
		if (x="velocity") output.add["Vel"];
		if (x="gravityacceleration") output.add["GravAccel"];
		if (x="mass") output.add["Mass"];
		if (x="potential") output.add["Potential"];
		if (x="oldacc") output.add["OldAcc"];
		if (x="id") output.add["ID"];
		if (x="type") output.add["Type"];
		if (x="tiend") output.add["Ti_endstep"];
		if (x="tibegin") output.add["Ti_begstep"];
		if (x="gravitycost") output.add["GravCost"];
	);
	
	var generateMethodInvoke:=method[x]
	{
		generateDotCode[dotstr];
		output.add["["];
		x.pop[].generateCode[];
		output.add["]"];
	};
		
	var getDotValue:=method[x,i]
	(
		return new unknown[];
	);
	
	var getdottype:=method[thestring]
	(
	 	return getKeywordType[thestring];
	);
	
	var getKeywordType:=method[thestring]
	{		
		if (thestring="position" || thestring="velocity" || thestring="gravityacceleration") 
		(
			var t:=new array[Floatt,3];
			t.setarg[new Range[3,3],1];
			var alloc:=new allocated[];
			alloc.allocationtype:=new multiple[];
			alloc + t;
			return alloc;
		);
		if (thestring="mass" || thestring="potential" || thestring="oldacc" || thestring="gravitycost") return Floatt;
		if (thestring="id" || thestring="type" || thestring="tiend" || thestring="tibegin") return Int;
		
	};
	
	var generateAssignment:=method[x,i]
	{
	skip;
	};
	
	var generateAccess:=method[x,i]
	{
		skip;
	};
	
	var setDotValue:=method[x,i]
	(
		true;
	);
	
	var generateDeclaration:=method[]
	(
		if (iamencapsulated==false)
		(
			output.add["MESHGADparticle "];
			(getVariable[]).generateName[];
			donedeclaration:=true;
			return true;
		);
		output.add["MESHGADparticle"];
	);	
	
	var clone:=method[]
    {
    	var rety:=new particletype[];	    	
    	rety.alone:=alone;
    	rety.iamencapsulated:=iamencapsulated;
    	rety.donedeclaration:=donedeclaration;    
    	rety.core:=core.clone[];
    	return rety;
    };
			
	var setarg:=method[x,i]
	(
		skip;
	);		
	
	var valid0:=method[] 
	(
		if (!alone) (core.valid6[];)	
	);	
	
	var getTy:=method[] return this;
	
	var getDeclaration:=method[] "MESHGADparticle";
	
	var setEncapsulated:=method[x] iamencapsulated:=x;		
		
	var check:=method[v]
	(
		if (v::thisclass) (return true;);
		return core.check[v];
	);
);
/* Will define the particle type at the end of core type - as lowest is not defned up to this point */