/*
File created 23/1/2008 by Nick Brown
*/

var partition:=class subType
(		
	var dynamic blocks;
	var dynamic number;
	var dynamic distmethod;
	var defn:=false;
	var btopid:=0;
	var scattervorgathervid:=0;
	
	var display:=method[]
	(
		print "partition -> ";
		core.display[];
	);		
	var setUpBlock:=method[] skip;
	var getDotValue:=method[which,i]
	{
		getBlockFromDistributionPartition[];
		att setUpBlock[];			
		if (which="blocks") return new Range[blocks.getsize[],blocks.getsize[]];		
		if (which="low") return Range[0,0];		
		if (which="high") 
		(
			var bid:=new stack[];
			i.retrieveMethodArgs[bid];
			if (bid.getsize[]==0) return null;
			return Range[blocks.aget[bid.top[].getValue[].a].a - 1,blocks.aget[bid.top[].getValue[].a].a - 1];
		);
		if (which="start")
		(
			var idx:=0;
			bid:=new stack[];
			i.retrieveMethodArgs[bid];			
			if (bid.getsize[]==0) return null;
			var j;
			for j from 0 to bid.top[].getValue[].a - 1
			(
				idx:=idx + blocks.aget[bid.top[].getValue[].a].a;
			);
			return return Range[idx + 1, idx + 1];
		);
		core.getDotValue[which,i];
	};
		
	var getdottype:=method[thestring]
	(	 		 	
		if (thestring="blocks") return Int;
		if (thestring="start") return Int;
		if (thestring="x") return Int;
		core.getdottype[thestring];	
	);
	
	var generate2ddisributedtranspositionuneven:=method[x,i]
	{
		var eachsubblocksamesize:=true;
		output.add["{"];
		var xType:=x.getstoredtype[];
		(getChainStart[]).generateDeclaration[];
		output.add["MESHtempvar;\n"];	// MUST free between iterations												
		// the code to generate for each block
		output.add["int MESHblockstoprocesses[]={"];
		var bi;					
		for bi from 0 to getBlocks[].getsize[] - 1
		(
			if (bi > 0) output.add[","];
			output.add[getBlocks[].lget[bi].getWhichProcessOn[]];
		);
		output.add["};\nint MESHblockatoprocesses[]={"];
		for bi from 0 to getBlocks[].getsize[] - 1
		(
			if (bi > 0) output.add[","];
			output.add[getBlocks[].lget[bi].a];
		);
		output.add["};\nint MESHblockbtoprocesses[]={"];
		for bi from 0 to getBlocks[].getsize[] - 1
		(
			if (bi > 0) output.add[","];
			output.add[getBlocks[].lget[bi].b];
			if ((((getBlocks[].lget[bi].b) % totalprocesses) * totalprocesses) != getBlocks[].lget[bi].b)
			(
				// the partition is split into subblocks with different sizes
				eachsubblocksamesize:=false;
			);
		);
		output.add["};\nint MESHblocksizetoprocesses[]={"];
		for bi from 0 to getBlocks[].getsize[] - 1
		(
			if (bi > 0) output.add[","];
			output.add[getBlocks[].lget[bi].size];
		);
							
		output.add["};\nint MESHblockdistributiontoprocesses["];
		output.add[totalprocesses];
		output.add["]["];
		output.add[totalprocesses];
		output.add["]={"];
		for bi from 0 to getBlocks[].getsize[] - 1
		(
			if (bi > 0) output.add[","];
			var basesize:=getBlocks[].lget[bi].b % number.a;
			var difference:=getBlocks[].lget[bi].b - (basesize * number.a);
			output.add["{"];
			var xx;								
			for xx from 0 to totalprocesses - 1
			(								
				if (xx > 0) output.add[","];
				var mysize:=basesize;
				if (difference > 0)
				(
					mysize:=mysize + 1;
					difference:=difference - 1;
				);		
				output.add[mysize]
			);
			output.add["}"];
		);
		output.add["};\nint MESHblocknum;\nfor(MESHblocknum=0;MESHblocknum<"];
		output.add[getBlocks[].getsize[]];
		output.add[";MESHblocknum++)\n{\n"];													
		output.add["if(myrank==MESHblockstoprocesses[MESHblocknum]){\n"];
		var blockb:=getBlocks[].lget[0].b;
		var eachblock:=(blockb % totalprocesses) * getBlocks[].lget[0].a;														
		output.add["MESHtempvar=("];
		(getChainStart[]).generateDeclaration[];
		output.add[") malloc(sizeof("];
		output.add[(getChainStart[]).getCoreType[].getDeclaration[]];							
		output.add[") * MESHblocksizetoprocesses[MESHblocknum]"];
		output.add[");\n"];														
		output.add["int MESHj,MESHd;"];
		output.add["for(MESHj=0;MESHj<MESHblockbtoprocesses[MESHblocknum]"];				
		output.add[";MESHj++){\nfor(MESHd=0;MESHd<MESHblockatoprocesses[MESHblocknum]"];							
		output.add[";MESHd++)\n{\n"];
		output.add["MESHtempvar[(MESHj * MESHblockatoprocesses[MESHblocknum]) + MESHd]"];
		output.add["="];
		x.generateName[];
		output.add["[(MESHd * MESHblockbtoprocesses[MESHblocknum]) + MESHj];\n}}"];
		// done the process transposition
		output.add["int MESHelementcount["];
		output.add[totalprocesses];
		output.add["];\nint MESHloopvar;\nfor(MESHloopvar=0;MESHloopvar<"];
		output.add[totalprocesses];
		output.add[";MESHloopvar++)\n{MESHelementcount[MESHloopvar]=(MESHblockatoprocesses[MESHblocknum] * MESHblockdistributiontoprocesses[MESHblocknum][MESHloopvar]) *"];
		output.add[getChainStart[].getCoreType[].getstoredtype[].getSize[].a];
		output.add[";}\n"];
		// IF MULTIPLE ELEMENTS PER ENTRY I.E. RECORD TYPE NEED TO MULTIPLY BY THIS VALUE!!
		output.add["\nint MESHelementdisplacement["];
		output.add[totalprocesses];
		output.add["];\nfor(MESHloopvar=0;MESHloopvar<"];
		output.add[totalprocesses];
		output.add[";MESHloopvar++)\n{if (MESHloopvar==0){\nMESHelementdisplacement[MESHloopvar]=0;\n}else{\n"];
		output.add["MESHelementdisplacement[MESHloopvar]=MESHelementdisplacement[MESHloopvar - 1] + (MESHelementcount[MESHloopvar - 1] /"];
		output.add[getChainStart[].getCoreType[].getstoredtype[].getSize[].a];
		output.add[");\n}}"];							
		// fill the number of elements for each process into array
							
		output.add["int MESHsendcnt;\nfor(MESHsendcnt=0;MESHsendcnt<"];
		output.add[totalprocesses];
		output.add[";MESHsendcnt++){\nMPI_Request MESHreq;\nMPI_Isend(&MESHtempvar[MESHelementdisplacement[MESHsendcnt]],MESHelementcount[MESHsendcnt],"];
		(getChainStart[]).getCoreType[].generateMPIDeclaration[];
		output.add[",MESHsendcnt,23,MPI_COMM_WORLD,&MESHreq);}\nMESHregistergarbage(MESHtempvar,1);\n"];
		output.newline[];														
		output.add["}}\n"];
							
		// recv bit now
		output.add["for(MESHblocknum=0;MESHblocknum<"];
		output.add[getBlocks[].getsize[]];
		output.add[";MESHblocknum++)\n{if(myrank==MESHblockstoprocesses[MESHblocknum]){\n"];
		(getChainStart[]).generateDeclaration[];
		output.add["MESHtempvar2=("];
		(getChainStart[]).generateDeclaration[];
		output.add[") malloc(sizeof("];
		output.add[(getChainStart[]).getCoreType[].getDeclaration[]];							
		output.add[") * MESHblocksizetoprocesses[MESHblocknum]"];
		output.add[");\n"];					
		output.add["int MESHstartpt=0;int MESHrecvcnt;MPI_Request MESHrequestlist["];
		output.add[totalprocesses];
		output.add["];\nfor(MESHrecvcnt=0;MESHrecvcnt<"];
		output.add[totalprocesses];
		output.add[";MESHrecvcnt++){\nMPI_Irecv(&MESHtempvar2"];
		output.add["[MESHstartpt],(MESHblockatoprocesses[myrank] *MESHblockdistributiontoprocesses[myrank][MESHrecvcnt]) *"];
		output.add[getChainStart[].getCoreType[].getstoredtype[].getSize[].a];
		output.add[","];
		(getChainStart[]).getCoreType[].generateMPIDeclaration[];
		output.add[",MESHrecvcnt,23,MPI_COMM_WORLD,&MESHrequestlist[MESHrecvcnt]);\n"];
							
		output.add["MESHstartpt=MESHstartpt + ((MESHblockatoprocesses[myrank] * MESHblockdistributiontoprocesses[myrank][MESHrecvcnt]) );}MPI_Waitall("];
		output.add[totalprocesses];
		output.add[",MESHrequestlist,MPI_STATUSES_IGNORE);"];
		output.newline[];																												
		
		output.add["int MESHi,MESHj,MESHd,MESHmc;\nint MESHcurrenta["];
		output.add[totalprocesses];
		output.add["];\nint MESHoffset=0;\nfor (MESHmc=0;MESHmc < "];
		output.add[totalprocesses];
		output.add[";MESHmc++){\nif (MESHmc==0){\nMESHcurrenta[0]=0;\n} else {\nMESHcurrenta[MESHmc]=MESHcurrenta[MESHmc - 1] + MESHblockdistributiontoprocesses[MESHblocknum][MESHmc - 1];}}"];		
		
		output.add["\nfor(MESHi=0;MESHi<"];
		output.add[totalprocesses];
		output.add[";MESHi++){\nint thissize=(MESHblockatoprocesses[MESHblocknum] * MESHblockdistributiontoprocesses[MESHblocknum][MESHi]);for(MESHd=0;MESHd<"];
		output.add["MESHblockatoprocesses[MESHblocknum]"];
		output.add[";MESHd++){\nfor(MESHj=0;MESHj<"];
		output.add["MESHblockdistributiontoprocesses[MESHblocknum][MESHi]"];
		output.add[";MESHj++){\n"];
		(getVariable[]).generateName[];
		output.add["[(MESHj + MESHcurrenta[MESHi])"];
		output.add[" + (MESHd * MESHblockbtoprocesses[MESHblocknum])"];
		output.add["]=MESHtempvar2[((MESHd * MESHblockdistributiontoprocesses[MESHblocknum][MESHi])"];
		output.add[" + MESHj) + MESHoffset];\n}}MESHoffset=MESHoffset + thissize;}free(MESHtempvar2);}}"];
		//output.add["free(MESHtempvar);\n"];						
		output.add["}"];					
		//output.add["free(MESHtempvar);}\n"];
		// code generation for each block completed :)
																										
	};
	
	var generate2ddisributedtranspositionallsamesize:=method[x,i]
	{
		output.add["{"];
												
		var blockb:=getBlocks[].lget[0].b;												
		var eachblock:=(blockb % totalprocesses) * getBlocks[].lget[0].a;							
		(getChainStart[]).generateDeclaration[];
		output.add["MESHtempvar=("];
		(getChainStart[]).generateDeclaration[];
		output.add[") malloc(sizeof("];
		output.add[(getChainStart[]).getCoreType[].getDeclaration[]];
		output.add[") * "];
		output.add[getBlocks[].lget[0].size];
		output.add[");\n"];						
		output.add["int MESHblocknum;\nfor(MESHblocknum=0;MESHblocknum<"];
		output.add[getBlocks[].getsize[]];
		output.add[";MESHblocknum++)\n{\n"];
		// the code to generate for each block
		output.add["int MESHblockstoprocesses[]={"];
		var bi;
		for bi from 0 to getBlocks[].getsize[] - 1
		(
			if (bi > 0) output.add[","];
			output.add[getBlocks[].lget[bi].getWhichProcessOn[]];
		);
		output.add["};\nif(myrank==MESHblockstoprocesses[MESHblocknum]){\n"];
		blockb:=getBlocks[].lget[0].b;
		eachblock:=(blockb % totalprocesses) * getBlocks[].lget[0].a;							
														
		output.add["int MESHj,MESHd;"];
		output.add["for(MESHj=0;MESHj<"];
		output.add[blockb];	// horizontal							
		output.add[";MESHj++)\n{\nfor(MESHd=0;MESHd<"];
		output.add[getBlocks[].lget[0].a];
		output.add[";MESHd++)\n{\n"];
		output.add["MESHtempvar["];
		output.add["(MESHj * "];
		output.add[getBlocks[].lget[0].a];
		output.add[") + MESHd]"];		
		output.add["="];
		x.generateName[];
		output.add["["];
		output.add["(MESHd * "];
		output.add[blockb];
		output.add[") + MESHj];\n}}\n"];
		// done the process transposition
		output.add["int MESHsendcounter;\nfor(MESHsendcounter=0;MESHsendcounter<"];
		output.add[totalprocesses];
		output.add[";MESHsendcounter++){\nMPI_Request MESHreq;\nMPI_Isend(&MESHtempvar[MESHsendcounter *"];
		output.add[(getBlocks[].lget[0].size % totalprocesses)];
		output.add["],"];
		output.add[(getBlocks[].lget[0].size % totalprocesses) * getChainStart[].getCoreType[].getstoredtype[].getSize[].a];
		output.add[","];
		(getChainStart[]).getCoreType[].generateMPIDeclaration[];
		output.add[",MESHsendcounter,23,MPI_COMM_WORLD,&MESHreq);"];
		output.newline[];
		output.add["}}}\n"];
		output.add["for(MESHblocknum=0;MESHblocknum<"];
		output.add[getBlocks[].getsize[]];
		output.add[";MESHblocknum++)\n{\n"];
		output.add["int MESHblockstoprocesses[]={"];
		for bi from 0 to getBlocks[].getsize[] - 1
		(
			if (bi > 0) output.add[","];
			output.add[getBlocks[].lget[bi].getWhichProcessOn[]];
		);
		output.add["};\nif(myrank==MESHblockstoprocesses[MESHblocknum]){\n"];
		(getChainStart[]).generateDeclaration[];
		output.add["MESHtempvar2=("];
		(getChainStart[]).generateDeclaration[];
		output.add[") malloc(sizeof("];
		output.add[(getChainStart[]).getCoreType[].getDeclaration[]];
		output.add[") * "];
		output.add[getBlocks[].lget[0].size];
		output.add[");\n"];							
		output.add["int MESHstartpt=0;int MESHrecvcounter;MPI_Request MESHrequestlist["];
		output.add[totalprocesses];
		output.add["];\nfor(MESHrecvcounter=0;MESHrecvcounter<"];
		output.add[totalprocesses];
		output.add[";MESHrecvcounter++){"];							
		output.add["\nMPI_Irecv(&MESHtempvar2[MESHstartpt],"];
		output.add[(getBlocks[].lget[0].size % totalprocesses) * getChainStart[].getCoreType[].getstoredtype[].getSize[].a];
		output.add[","];
		(getChainStart[]).getCoreType[].generateMPIDeclaration[];
		output.add[",MESHrecvcounter,23,MPI_COMM_WORLD,&MESHrequestlist[MESHrecvcounter]);\nMESHstartpt=MESHstartpt +"];
		output.add[(getBlocks[].lget[0].size % totalprocesses)];
							
		output.add[";\n}MPI_Waitall("];
		output.add[totalprocesses];
		output.add[",MESHrequestlist,MPI_STATUSES_IGNORE);\n"];														
		output.newline[];
		// all received, now need to perform transposition step into actual memory!
		// code generation for each block completed :)
		output.add["int MESHi,MESHj,MESHd;\nfor(MESHi=0;MESHi<"];
		output.add[totalprocesses];
		output.add[";MESHi++){\nfor(MESHd=0;MESHd<"];
		output.add[blockb % totalprocesses];
		output.add[";MESHd++){\nfor(MESHj=0;MESHj<"];
		output.add[blockb % totalprocesses];
		output.add[";MESHj++){\n"];
		(getVariable[]).generateName[];
		output.add["[(MESHj + ("];
		output.add[getBlocks[].lget[0].a];
		output.add["* MESHi)) + (MESHd *"];
		output.add[blockb];
		output.add[")]=MESHtempvar2[((MESHd *"];
		output.add[blockb % totalprocesses];
		output.add[") + MESHj) + (MESHi * "];
		output.add[(getBlocks[].lget[0].size % totalprocesses)];
		output.add[")];\n}}}free(MESHtempvar2);}}"];
		//output.add["free(MESHtempvar);\n"];						
		output.add["}"];
	};
			
	var setDistribution:=method[x] distmethod:=x;
	var init:=method[]
	(
		super;
		startroot[];	
		blocks:=new ArrayList[];						
		this
	);		
	
	var generateCountsandDisplacements:=method[theblocks,ctr]
	{				
		var sizeofelements:=((getVariable[]).getstoredtype[].getCoreType[].getstoredtype[].getSize[]).a;		
		output.add["int counts"];
		output.add[ctr];
		output.add["[]={"];
		var i;
		var comma:=false;
		for i from 0 to totalprocesses - 1
		(
			if (comma==false)
			(
				comma:=true;
			) else (
				output.add[","];
			);
			var blocksonme:=getBlocksOn[i,theblocks];
			var tot:=0;
			if (blocksonme.getsize[] > 0)
			(
				var j:=blocksonme.agetiterator[];
				while (j.hasNext[])
				(
					tot:=tot + ((j.next[]).getdata[]).getSize[];		
				);
			) else (
				tot:=0;
			);
			tot:=tot * sizeofelements;
			output.add[tot];
		);
		output.add["};\n"];
		
		output.add["int displacements"];
		output.add[ctr];
		output.add["[]={"];
				
		var sum:=0;
		comma:=false;
		for i from 0 to totalprocesses - 1
		(
			if (comma==false)
			(
				comma:=true;
			) else (
				output.add[","];
			);
			blocksonme:=getBlocksOn[i,theblocks];
			tot:=0;
			if (blocksonme.getsize[] > 0)
			(
				j:=blocksonme.agetiterator[];
				while (j.hasNext[])
				(
					tot:=tot + ((j.next[]).getdata[]).getSize[];		
				);
			) else (
				tot:=0;
			);
			output.add[sum];
			sum:=sum + (tot * sizeofelements);			
		);
		output.add["};\n"];
	};
	
	var generateScatterV:=method[x,i,v,theblocks,ctr]
	{
		output.add["MPI_Scatterv(&"];
		x.generateMethodInvoke[new stack[]];
		output.add[",counts"];
		output.add[ctr];
		output.add[",displacements"];
		output.add[ctr];
		output.add[","];
		(x.getstoredtype[].getCoreType[]).generateMPIDeclaration[];
		output.add[",&"];
		v.generateMethodInvoke[i];
		output.add[","];		
		if (output.getSelect[] == 0)
		(
			var oldout:=output.getSelect[];
			var j;
			for j from 0 to totalprocesses - 1
			(
				output.setSelect[j + 1];
				output.add[getSizeofDataOnProcess[j,theblocks]];
			);			
			output.setSelect[oldout];
		) else (
			output.add[getSizeofDataOnProcess[parallelgeneratecounter - 1,theblocks]];
		);
		output.add[","];
		(v.getstoredtype[].getCoreType[]).generateMPIDeclaration[];
		output.add[","];
		(x.getstoredtype[].getheldon[]).generateCode[];
		output.add[",MPI_COMM_WORLD);"];
		output.newline[];
	};
	
	var generateGatherV:=method[x,i,v,theblocks,ctr]
	{
		output.add["MPI_Gatherv(&"];
		v.generateMethodInvoke[i];
		output.add[","];
		if (output.getSelect[] == 0)
		(
			var oldout:=output.getSelect[];
			var j;
			for j from 0 to totalprocesses - 1
			(
				output.setSelect[j + 1];
				output.add[getSizeofDataOnProcess[j,theblocks]];
			);
			output.setSelect[oldout];
		) else (
			output.add[getSizeofDataOnProcess[parallelgeneratecounter - 1,theblocks]];
		);
		output.add[","];
		(x.getstoredtype[].getCoreType[]).generateMPIDeclaration[];
		output.add[",&"];
		x.generateMethodInvoke[new stack[]];
		output.add[",counts"];
		output.add[ctr];
		output.add[",displacements"];
		output.add[ctr];
		output.add[","];
		(v.getstoredtype[].getCoreType[]).generateMPIDeclaration[];
		output.add[","];
		(x.getstoredtype[].getheldon[]).generateCode[];
		output.add[",MPI_COMM_WORLD);"];
		output.newline[];				
	};
	
	var getSizeofDataOnProcess:=method[c,bs]
	{
		var thebs:=getBlocksOn[c,bs];
		var tot:=0;
		var i:=thebs.agetiterator[];
		while (i.hasNext[])
		(
			tot:=tot + ((i.next[]).getdata[]).getSize[];
		);		
		tot := tot * (getVariable[]).getstoredtype[].getCoreType[].getstoredtype[].getSize[].a;		
		return tot;
	};
	
	var getBlocksOn:=method[c,bs]
	{
		var tor:=new ArrayList[];
		var i:=bs.agetiterator[];
		while (i.hasNext[])
		(
			var tb:=(i.next[]).getdata[];
			if ((tb.getWhichProcessOn[])==c) tor.aadd[tb];			
		);
		return tor;
	};
	
	var getPartition:=method[] this;
	
	var eachBlockSameSize:=method[]
	{
		if (blocks.getsize[]==0) return true;
		var i:=blocks.agetiterator[];
		var currentnum:=((i.next[]).getdata[]).getSize[];
		while (i.hasNext[])
		{
			if (currentnum != ((i.next[]).getdata[]).getSize[]) return false;
		};
		return true;
	};
	var optimiseAssignment:=method[x,i] fillblocks[];
	var optimiseAccess:=method[x,i] fillblocks[];
	
	var getBlocks:=method[] 
	(
		if (blocks.getsize[]==0) fillBlocks[];
		return blocks;
	);
	
	var getLocatedOn:=method[x]
	{
		if (x.getsize[] > 0)
		(
			var bid:=x.top[];
			if !(bid :: Range) bid:=bid.getValue[];			
			return (blocks.aget[bid.a]).getWhichProcessOn[];
		);
	};
	
	var getBlockFromDistributionPartition:=method[]
	{
		var dpartition:=(getVariable[]).getstoredtype[].getDistributionPartition[];				
		// calls the distribution partition - what if there is none - return null!
		if (blocks.getsize[]==0)	// dont do if already filled
		(
			if (!(dpartition==null))
			(
				var newblocks:=dpartition.getBlocks[];						
				blocks:=newblocks.clone[];
			) else (							
				blocks:=getBlocks[];
			);
		);
	};
	
	var getPhysicalSize:=method[]
	{
		getBlockFromDistributionPartition[];
		att setUpBlock[];
		var perprocess:=new ArrayList[];
		var i;
		for i from 0 to blocks.getsize[] - 1
		(
			var thesize:=blocks.aget[i].getSize[];
			var onprocess:=blocks.aget[i].getWhichProcessOn[];
			if (perprocess.aget[onprocess]==null)
			(
				perprocess.aadd[thesize];
			) else (
				var cs:=perprocess.aget[onprocess];
				cs:=cs + thesize;
				perprocess.aput[onprocess,cs];
			);	
		);		
		return perprocess;
	};
	
	var generateDynamicRecv:=method[x,i,dest]
	{
		/*
			Overrides the method in basiccomm - needed to allow for not all blocks the same size, pid != blockid and also to clean up the getting index too
		*/
		if (!(dest :: Range))
		(
			output.add["int blockstoprocessid"];
			output.add[btopid];
			output.add["[]={"];
			var comma:=false;
			var j:=blocks.agetiterator[];
			while (j.hasNext[])
			(
				if (comma==false)
				(
					comma:=true;
				) else (
					output.add[","];
				);
				output.add[j.next[].getdata[].getWhichProcessOn[]];
			);
			output.add["};"];
			output.newline[];
			if (eachBlockSameSize[]==false)
			(
				output.add["int sizeofeachblock"];
				output.add[btopid];
				output.add["[]={"];
				comma:=false;
				j:=blocks.agetiterator[];
				while (j.hasNext[])
				(
					if (comma==false)
					(
						comma:=true;
					) else (
						output.add[","];
					);
					output.add[j.next[].getdata[].b];
				);
				output.add["};"];
				output.newline[];
			);
		);
		if (x.hasBeenDeclared[]==false)
 		(
 			x.generateCode[];
 			output.add[";\n"];
 		);
    	output.add["MESHrecvdynamic(&"];
    	x.generateCode[]; 	
    	var sizeofdata:=1;	
    	if (i.getsize[]==2)
    	(
    		if (eachBlockSameSize[]==true)
    		(
    			sizeofdata:=blocks.aget[0].b;
    		) else (
    			if (dest :: Range)
    			(
    				sizeofdata:=blocks.aget[dest.a].b;
    			) else (
    				output.add[sizeofeachblock];
    				output.add[btopid];
    				output.add["["];
    				dest.generateCode[];
    				output.add["]"];
    				sizeofdata:=null;
    			);
    		);
    	);
    	output.add[","];
    	if (!(sizeofdata==null)) output.add[sizeofdata];    	    	
    	output.add[","];
 		(((getVariable[]).getstoredtype[]).getCoreType[]).generateMPIDeclaration[];
 		output.add[","];
 		output.add[((getVariable[]).getstoredtype[]).getSharedPoolID[]]; 
 		output.add[","];
 		if !(i==null)
 		(
 			// NEED A BIT SPECIFIC TO THE PARTITION I.E. in vertical
 			 var blockid:=i.pop[];
 			var sizeofarg:=i.getsize[];
 			(i.lget[1]).generateCode[];
 			output.add["*"];
 			output.add[blocks.aget[blockid.getValue[].a].a];		
 			if (sizeofarg==2)
 			( 			 				
 				output.add["+"];
 				i.top[].generateCode[]; 			
 			)
 		) else (
 			output.add["0"];
 		);	
 		output.add[","];

 		//output.add[dest];
 		if (dest :: Range)
 		(
 			output.add[(blocks.aget[dest.a]).getWhichProcessOn[]];
 		) else (
 			output.add["blockstoprocessid"];
 			output.add[btopid];
 			output.add["["];
 			dest.generateCode[];
 			output.add["]"];
 		);
 		output.add[");"];
 		output.newline[];
 		btopid:=btopid + 1;
	};
	
	var fillBlocks:=method[]
	{		
		if (blocks.getsize[]==0)
		(			
			var i;
			var disty:=((getVariable[]).getstoredtype[]).isDistributed[];
			for i from 0 to number.a - 1
			(
				var block:=new basicblock[];
				block.setSize[0];
				block.setBlockType[((getVariable[]).getstoredtype[]).t];
				if (disty==false)
				(
					var hon:=((getVariable[]).getstoredtype[]).getheldon[];
					if (hon==false)
					(
						block.setWhichProcessOn[false];
					) else (					
						block.setWhichProcessOn[((getVariable[]).getstoredtype[]).getheldon[].getValue[].a];
					);
				);
				blocks.aadd[block];	
			);
			if (((getVariable[]).getstoredtype[]).isDistributed[]==true)
			(
				// needs to allocate which block belongs to which process				
				distmethod.setBlockDistribution[blocks];				
			);
		);
	};
	
	var setarg:=method[x,i]
	(			
		if (i==0) 
		(
			if ( ((x.getValue[])==null) || ((x.getValue[]) :: unknown))
			(
				number:=x;
			) else (
				number:=(x.getValue[]);
			);							
		);
	);
	
	var getId:=method[] return 5;
	
	var clone:=method[]
    {
    	var rety:=new partition[];	
    	rety.blocks:=blocks;    	
    	rety.distmethod:=distmethod;
    	rety.number:=number;  
    	rety.alone:=alone;
    	rety.core:=core.clone[];    
    	return rety;
    };        
    
    var valid1:=method[] 
	(
		if (!alone) (this.core.valid5[];)	
	);	
	
	var valid11:=method[] 
	(
		if (!alone) (this.core.valid5[];)	
	);
		
	var check:=method[v]
	(
		if (v::thisclass) (return true;);
		return core.check[v];
	);
);