/*
File created 2/12/2008 by Nick Brown
*/

var referencerecord:=class record
(	
	var dynamic donetyperesolution:=false;
	var dynamic donedecs:=false;
	//var dynamic 
	var doneintern:=false;
	var clone:=method[]
	{
		var duplication:=new referencerecord[];	
		duplication.donetyperesolution:=donetyperesolution;
		duplication.donedecs:=donedecs;
		duplication.alltsame:=alltsame;
		duplication.contents:=contents;
		duplication.donegendec:=true;
		duplication.first:=first;
		setThisName[];
		duplication.myname:=myname;
		duplication.donetypedef:=donetypedef;
		duplication.alone:=alone;
		duplication.directuse:=directuse;
    	duplication.core:=core.clone[]; 
		return duplication;
	};
	
	var getSize:=method[] return Range[1,1];
	
	var init:=method[] 
	(				
		super;	
		startroot[];	
		contents:=new HashMap[];						
		setThisName[];
		dependency.addinclude["<stdlib.h>"];
		this;
	);	
	
	var adummymethod:=method[]
	 (
	 	/*
	 		Whats the point of this? Well, if the user types a var x::Int, rather than using
	 		Int[], which is not to be expected with Int, Float etc... then e1 will be of
	 		type code, need to eval it to get the coretype representation that can work with.
	 		This is also of type code and is used to get the type of and check against the type
	 		of e1 - as we DO NOT want to call eval on s[], because it will do methodinvoke's eval	 	
	 	*/
	 	skip;
	 );
	
	var getDotisStructurePointer:=method[] true;
		
	var getdottype:=method[thestring]
	 (	 		 
	 	resolveTypes[];		 	
	 	//print (getVariable[]).setPointer[true];
	 	// add check - if aget == null then throw error
	 	if (contents.hget[thestring]==null) throw error "Error - Dot does not exist in record";	 		 
	 	if (((contents.hget[thestring]).aget[0]) == null)
	 	(
	 		return this;
	 	);	 	
	 	if (!(((contents.hget[thestring]).aget[0]) :: array)) if (((contents.hget[thestring]).aget[0]).getDeclaration[] = ((getVariable[]).getstoredtype[].getRecordName[])) return ((getVariable[]).getstoredtype[]).clone[];
	 //	(contents.hget[thestring]).aget[0].display[];
	 	return (contents.hget[thestring]).aget[0];	 	
	 );
	
	/*
	var generateDotCode:=method[x]
	{
		(getVariable[]).generateName[];
		output.add["->"];
		output.add[x];
	};
	*/
	
	var generateDeclaration:=method[]
	(		
		setThisName[];
		if (donegendec==false)
		(
			donegendec:=true;
			output.ignoretillnewline[];
		) else (
			output.add[myname];	
			output.add["*"];		
			//output.add[getVariable[].getName[]];
		);			
		/*
			The reason for the below is that if it is the point where we want to generate
			the typedef code (as in generateCode) then the name of this and also var name 
			are equal - so return false so that it calls that routine.
			
			Else, we are using this as a type e.g. var a : complex - here just generate this
			declaration and then do nothing after
		*/
		if (myname = getVariable[].getName[]) return false;
		//return 13;
	);
	
	var generateAssignment:=method[x,i] 
	{
		skip;
	};
	
	var optimiseAccess:=method[x,i]
	{
		x.getCurrentType[].overrideDefaultShared[true];
	};
	
	var generateAccess:=method[x,i]
	{
		if (dotstr != "") return null;
		resolveTypes[];
		if (((getChainStart[]).getheldon[] != false) && (!((getChainStart[]).getheldon[] == null)) && (x.getstoredtype[].getheldon[]==false))
		(			
			var meon:=(getChainStart[].getheldon[]).getValue[];
			output.add["if (myrank=="];
			output.add[meon];
			output.add[")\n"];
			output.add["{"];
			generateSetUpDataTable[];			
			output.add["MPI_Bcast(MESHrefmsgsizes,2,MPI_INT,"];
			output.add[meon];
			output.add[",MPI_COMM_WORLD);\nMPI_Bcast(MESHrefabstable,MESHrefmsgsizes[0],MPI_BYTE,"];
			output.add[meon];
			output.add[",MPI_COMM_WORLD);\nMPI_Bcast(MESHrefdata,MESHrefmsgsizes[1],MPI_BYTE,"];
			output.add[meon];
			output.add[",MPI_COMM_WORLD);\nfree(MESHrefabstable);\nMESHrefrecorddisposetable("];
			(getVariable[]).generateName[];
			output.add[");\nfree(MESHrefdata);\n"];
			x.generateCode[];
			output.add["="];
			(getVariable[]).generateCode[];
			output.add[";\n} else {\n"];
			generateGetDataTable[];
			x.generateCode[];
			output.add["=MESHrefdata;\n"];
			output.add["INTERNconnectdata(MESHrefdata,MESHrefdata);\n"];
			output.add["MESHrefrecorddisposetable(MESHrefdata);"];
			output.newline[];
			output.add["}"];
			if (doneintern==false) generateInternalAnalysisFunction[];
			if (doneintern==false) generateInternalConnectFunction[];
			doneintern:=true;
			return true;
		);
	};
	
	var generateGetDataTable:=method[]
	{
		var itsy:=contents.hgetiterator[];
		var numberstruct:=0;
		var meon:=(getChainStart[].getheldon[]).getValue[];
		output.add["char * MESHstructdata = \""];
		while (itsy.hasNext[])
		(
			var node:=itsy.next[];			
			if (((node.getdata[]).aget[2]) == true)
			(
				output.add[node.gethash[]];
				output.add["\\0"];
				numberstruct:=numberstruct + 1;
			);
		);
		output.add["\";"];
		output.newline[];
		output.add["int MESHdatasizes[2];\nMPI_Bcast(MESHdatasizes,2,MPI_INT,"];
		output.add[meon];
		output.add[",MPI_COMM_WORLD);\n"];
		output.add["void * MESHreftable=malloc(sizeof(char) * MESHdatasizes[0]);\n"];
		output.add["void * MESHrefdata=malloc(sizeof(char) * MESHdatasizes[1]);\n"];
		
		output.add["MESHrefrecordcreate("];
		output.add[numberstruct];
		output.add[",MESHstructdata,MESHrefdata);\n"];	
		output.add["MPI_Bcast(MESHreftable,MESHdatasizes[0],MPI_BYTE,"];
		output.add[meon];
		output.add[",MPI_COMM_WORLD);\n"];
		
		output.add["MPI_Bcast(MESHrefdata,MESHdatasizes[1],MPI_BYTE,"];
		output.add[meon];
		output.add[",MPI_COMM_WORLD);\n"];
		output.add["MESHrefrecordconstructtablefromabstable(MESHrefdata,MESHreftable);\n"];
		output.add["free(MESHreftable);\n"];		
	};
	
	var generateSetUpDataTable:=method[]
	{
		var itsy:=contents.hgetiterator[];
		var numberstruct:=0;
		output.add["char * MESHstructdata = \""];
		while (itsy.hasNext[])
		(
			var node:=itsy.next[];			
			if (((node.getdata[]).aget[2]) == true)
			(
				output.add[node.gethash[]];
				output.add["\\0"];
				numberstruct:=numberstruct + 1;
			);
		);
		output.add["\";"];
		output.newline[];
		output.add["MESHrefrecordcreate("];
		output.add[numberstruct];
		output.add[",MESHstructdata,"];
		(getVariable[]).generateName[];
		output.add[");\n"];
			
		output.add["INTERNanalyse("];
		(getVariable[]).generateName[];
		output.add[",sizeof("];
		output.add[myname];
		output.add["),"];
		(getVariable[]).generateName[];
		output.add[");\n"];
		
		
		output.add["MESHrefrecordlinkrelativeaddresses("];
		(getVariable[]).generateName[];
		output.add[");\n"];
		output.add["void * MESHrefdata=MESHrefrecordallignmemory("];
		(getVariable[]).generateName[];
		output.add[");\nvoid * MESHrefabstable=MESHrefrecordgetabstracttable("];
		(getVariable[]).generateName[];
		output.add[");\nint MESHrefmsgsizes[]={MESHrefrecordgetabstablesize("];
		(getVariable[]).generateName[];
		output.add["),MESHrefrecordgettotmemsize("];
		(getVariable[]).generateName[];
		output.add[")};\n"];
	};
	
	var generateInternalConnectFunction:=method[]
	{
		output.addMethodProto["void INTERNconnectdata("];
		output.addMethodProto[myname];
		output.addMethodProto["*,"];
		output.addMethodProto[myname];
		output.addMethodProto["*);"];
		output.newlineMethodProto[];
		var currentm:=output.getMethod[];
		//var ufn:=output.getInAUserFunction[];
		var mp:=output.addMethod["INTERNconnectdata"];	
		output.selectMethod[mp];
		output.add["void INTERNconnectdata("];
		output.add[myname];
		output.add["* node,"];
		output.add[myname];
		output.add["* base)\n{"];
		//output.add["MESHrefrecordaddtablerow(node,s,base);\n"];
		var itsy:=contents.hgetiterator[];
		while (itsy.hasNext[])
		(
			var node:=itsy.next[];			
			if (((node.getdata[]).aget[2]) == true)
			(
				output.add["node->"];
				output.add[node.gethash[]];
				output.add["="];
				output.add["MESHrefrecordgetrowentry(MESHrefrecordgetrownumber(node,base),\""];
				output.add[node.gethash[]];
				output.add["\\0\",base);\n"];
			);
		);
		output.add["int rownum=MESHrefrecordgetrownumber(node,base);\nMESHrefrecordremoverow(node,base);\n"];
		itsy:=contents.hgetiterator[];
		while (itsy.hasNext[])
		(
			var newnode:=itsy.next[];			
			if (((newnode.getdata[]).aget[2]) == true)
			(
				output.add["if (MESHrefrecordneedtolinkfurther(rownum,\""];
				output.add[newnode.gethash[]];
				output.add["\\0\",base)==1) INTERNconnectdata(node->"];
				output.add[newnode.gethash[]];
				output.add[",base);\n"];
			);
		);
		output.add["}"];
		//if (ufn==true)
		//(
			output.selectMethod[currentm];
		//) else (
			//output.setHardSelect[currentp];
		//);
	};
	
	var generateInternalAnalysisFunction:=method[]
	{
		
		var currentp;
		//if (ufn==true)
		//(
		//	currentp:=output.getSelect[];
			var currentm:=output.getMethod[];
		output.addMethodProto["void INTERNanalyse("];
		output.addMethodProto[myname];
		output.addMethodProto["*,int,"];
		output.addMethodProto[myname];
		output.addMethodProto["*);"];
		output.newlineMethodProto[];
		//var ufn:=output.getInAUserFunction[];
		
		//) else (
		//	currentp:=output.getSelect[];
		//);		
		
		//print output.getParallelMethod[];
		var mp:=output.addMethod["INTERNanalyse"];	
		output.selectMethod[mp];
		output.add["void INTERNanalyse("];
		
		output.add[myname];
		output.add["* node,int s,"];
		output.add[myname];
		output.add["* base)\n{"];
		output.add["MESHrefrecordtableaddrow(node,s,base);\n"];
		var itsy:=contents.hgetiterator[];
		while (itsy.hasNext[])
		(
			var node:=itsy.next[];			
			if (((node.getdata[]).aget[2]) == true)
			(
				output.add["MESHrefrecordaddrowentry(MESHrefrecordgetrownumber(node,base),\""];
				output.add[node.gethash[]];
				output.add["\\0\",node->"];				
				output.add[node.gethash[]];
				output.add[",base);\n"];
			);
		);
		itsy:=contents.hgetiterator[];
		while (itsy.hasNext[])
		(
			var newnode:=itsy.next[];			
			if (((newnode.getdata[]).aget[2]) == true)
			(
				output.add["if (MESHrefrecordneedtoanalysefurther(MESHrefrecordgetrownumber(node,base),\""];
				output.add[newnode.gethash[]];
				output.add["\\0\",base)==1) INTERNanalyse(node->"];
				output.add[newnode.gethash[]];
				output.add[",sizeof("];
				output.add[myname];
				output.add["),base);\n"];
			);
		);
		output.add["}"];
		//if (ufn==true)
		//(
			
		//) else (
		
			//output.setHardSelect[currentp];
			output.selectMethod[currentm];
		
		//);
	};
	
	var setarg:=method[x,i]
	{		
		directuse:=true;
		var stage:=i % 2;
		var ministage:=i - (stage * 2);	
		if (ministage==0)
		(
			var listtoadd:=new ArrayList[];
			contents.hput[x.getValue[],listtoadd];
			prevname:=x.getValue[];
		);
		var btype;
		if (ministage==1) 
		(			
			if (i==1) 
			(
				btype:=x;
			) else (		
				if ((btype.check[x]) == false) alltsame:=false;				
			);
			var thelist:=contents.hget[prevname];
			thelist.aadd[x];
			thelist.aadd[new unknown];
			contents.hput[prevname,thelist];
		);
	};
	
	var resolveTypes:=method[]
	{
		if (donetyperesolution==true) return null;
		donetyperesolution:=true;
		var i:=contents.hgetiterator[];
		var newcontents:=new HashMap[];
		while (i.hasNext[])
		(
			var nodething:=i.next[];
			var thelist:=nodething.getdata[];
			var x:=thelist.aget[0];
			var temptype;			
			var struct:=false;
			if ((x.getType[]).check[((this.adummymethod).body).getType[]])
	 		(
	 			temptype:=x.eval[];
	 		) else (	 	
	 			struct:=true;
				temptype:=x.getTy[];
			);
			var newList:=new ArrayList[];
			newList.aadd[temptype];
			newList.aadd[new unknown[]];
			newList.aadd[struct];
		//	contents.hremove[nodething.gethash[]];
			newcontents.hput[nodething.gethash[],newList];
		);
		contents:=newcontents;
	};
	
	var generateCode:=method[]
	{					
		resolveTypes[];	
		//output.clearline[];
		if (donetypedef==false)	// if already generated type def dont redo
		(
			donetypedef:=true;
			setThisName[];
			output.clearline[];	
			output.add["typedef struct "];
			output.add["recordtype"];
			output.add[totalnum];
			totalnum:=totalnum + 1;
			output.add["{"];
			var itsy:=contents.hgetiterator[];
			while (itsy.hasNext[])
			(
				var node:=itsy.next[];	
				var selfref:=false;		
				// added to below, if its an array of me will still generate correctly		
				if (( ((node.getdata[]).aget[0]) == null) || (((getVariable[]).getstoredtype[].getRecordName[]) == ((node.getdata[]).aget[0]).getDeclaration[]))
				(
					output.add["struct recordtype"];
					output.add[totalnum - 1];
					selfref:=true;
				) else (
					output.add[((node.getdata[]).aget[0]).getDeclaration[]];
				);
				if (selfref==true)
				(
					output.add["*"];
				);
				output.add[" "];
				output.add[node.gethash[]];	
				if (!( ((node.getdata[]).aget[0]) == null)		)
				(
				if ((((node.getdata[]).aget[0]).getSize[]).a > 1)
				(
					output.add["["];
					output.add[((node.getdata[]).aget[0]).getSize[]];
					output.add["]"];
				);
				);
				output.add[";"];
			);					
			output.add["}"];
			output.add[myname];
		) else (
			// a var has been declared as this reference record			
			output.add["malloc(sizeof("];
			output.add[myname];
			output.add["));"];
			output.newline[];
			return true;
		);
	};
	
	var getMethodStar:=method[] return core.getMethodStar[] + 1;
);